package org.modelbus.team.eclipse.changemodelnotification.commit;

import java.util.HashMap;

import org.eclipse.emf.transaction.TransactionalEditingDomain;

public class ModelBusChangeManager {

	private static ModelBusChangeManager												modelBusChangeManager;

	private static HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter>	domainToChangeManagerMap;

	private ModelBusChangeManager() {

	}

	public static ModelBusChangeManager getModelBusChangeManager() {
		if (modelBusChangeManager == null) {
			modelBusChangeManager = new ModelBusChangeManager();
		}
		return modelBusChangeManager;
	}

	public ModelBusChangeRecorderConverter getModelBusChangeRecorderConverter(TransactionalEditingDomain domain) {

		if (domainToChangeManagerMap == null) {
			domainToChangeManagerMap = new HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter>();
		}
		if (domainToChangeManagerMap.get(domain) == null) {
			ModelBusChangeRecorderConverter modelBusChangeRecorderConverter = new ModelBusChangeRecorderConverter(domain);
			domainToChangeManagerMap.put(domain, modelBusChangeRecorderConverter);
		}

		return domainToChangeManagerMap.get(domain);

	}

	protected static HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter> getDomainToChangeManagerMap() {
		if (domainToChangeManagerMap == null) {
			domainToChangeManagerMap = new HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter>();
		}
		return domainToChangeManagerMap;
	}

}
