package org.modelbus.team.eclipse.changemodelnotification.commit;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.BasicEMap;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EStructuralFeature.Setting;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.change.ChangeDescription;
import org.eclipse.emf.ecore.change.ChangeFactory;
import org.eclipse.emf.ecore.change.ChangeKind;
import org.eclipse.emf.ecore.change.ChangePackage;
import org.eclipse.emf.ecore.change.FeatureChange;
import org.eclipse.emf.ecore.change.ListChange;
import org.eclipse.emf.ecore.change.ResourceChange;
import org.eclipse.emf.ecore.change.impl.ChangeDescriptionImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.EcoreUtil.Copier;
import org.eclipse.emf.ecore.xmi.XMIResource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.modelbus.core.lib.util.ModelBusCoreUtil.URIUtil;
import org.modelbus.team.eclipse.changemodelnotification.util.ChangeModelUtil;

public class ModelBusChangeRecorderConverter {

	// private ModelBusChangeRecorderConverter changeRecorder;
	private TransactionalEditingDomain			domain;
	private List<Notification>					recordedNotifications;
	// private HashMap<ModelBusChangeRecorderConverter, List<Notification>> recordedNotificationsMap;
	private Map<EObject, String>				eObjetToIDMap;
	// private HashMap<ModelBusChangeRecorderConverter, Map<EObject, String>> changeManagerToEObjetToIDMap;
	private Copier								copier;
	// private HashMap<ModelBusChangeRecorderConverter, Copier> changeManagerToCopierMap;
	private Map<Resource, String>				resourceToUriMap;
	// private HashMap<ModelBusChangeRecorderConverter, Map<Resource,String>> changeManagerToResourceToUriMap;
	private ChangeDescription					changeDescription;
	// private HashMap<ModelBusChangeRecorderConverter, ChangeDescription> changeManagerToCchangeDescriptionMap;
	private List<EObject>						objectsToAttach;

	private Map<FeatureChange, EList<Object>>	featureChangeToOldValueMap;

	// private HashMap<ModelBusChangeRecorderConverter, List<EObject>> changeManagerToObjectsToAttachMap;
	// private static HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter> domainToChangeManagerMap;

	public ModelBusChangeRecorderConverter(TransactionalEditingDomain domain) {
		this.domain = domain;
		// this.changeRecorder = this;
	}

	// private ModelBusChangeRecorderConverter(){
	//
	// }

	// public static ChangeManager getChangeManager(){
	// if(changeManager == null){
	// changeManager = new ChangeManager();
	//
	// }
	//
	// return changeManager;
	// }

	// public static ModelBusChangeRecorderConverter getChangeManager(TransactionalEditingDomain domain){
	//
	// if(domainToChangeManagerMap == null){
	// domainToChangeManagerMap = new HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter>();
	//
	// }
	// if(!domainToChangeManagerMap.containsKey(domain)){
	// ModelBusChangeRecorderConverter changeManager = new ModelBusChangeRecorderConverter();
	// domainToChangeManagerMap.put(domain, changeManager);
	// }
	//
	// return domainToChangeManagerMap.get(domain);
	// }

	// private HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter> getDomainToChangeManagerMap(){
	// if(domainToChangeManagerMap == null){
	// domainToChangeManagerMap = new HashMap<TransactionalEditingDomain, ModelBusChangeRecorderConverter>();
	//
	// }
	//
	// return domainToChangeManagerMap;
	// }

	private ChangeDescription getChangeDescription() {
		if (changeDescription == null) {
			changeDescription = ChangeFactory.eINSTANCE.createChangeDescription();
		}
		return changeDescription;
	}

	// private ChangeDescription getChangeDescription(ModelBusChangeRecorderConverter changeManager){
	// if(changeManagerToCchangeDescriptionMap == null){
	// changeManagerToCchangeDescriptionMap = new HashMap<ModelBusChangeRecorderConverter, ChangeDescription>();
	//
	// }
	// if(!changeManagerToCchangeDescriptionMap.containsKey(changeManager)){
	// ChangeDescription changeDescription = ChangeFactory.eINSTANCE.createChangeDescription();
	// changeManagerToCchangeDescriptionMap.put(changeManager, changeDescription);
	// }
	// return changeManagerToCchangeDescriptionMap.get(changeManager);
	// }

	private List<EObject> getObjectsToAttach() {
		if (objectsToAttach == null) {
			objectsToAttach = new ArrayList<EObject>();
		}
		return objectsToAttach;
	}

	private Map<FeatureChange, EList<Object>> getFeatureChangeToOldValueMap() {
		if (featureChangeToOldValueMap == null) {
			featureChangeToOldValueMap = new HashMap<FeatureChange, EList<Object>>();
		}
		return featureChangeToOldValueMap;
	}

	// private List<EObject> getObjectsToAttach(ModelBusChangeRecorderConverter changeManager){
	// if(changeManagerToObjectsToAttachMap == null){
	// changeManagerToObjectsToAttachMap = new HashMap<ModelBusChangeRecorderConverter, List<EObject>>();
	//
	// }
	// if(!changeManagerToObjectsToAttachMap.containsKey(changeManager)){
	// List<EObject> objectsToAttach = new ArrayList<EObject>();
	// changeManagerToObjectsToAttachMap.put(changeManager, objectsToAttach);
	// }
	// return changeManagerToObjectsToAttachMap.get(changeManager);
	// }

	private Copier getCopier() {
		if (copier == null) {
			copier = new Copier();
		}
		return copier;
	}

	// private Copier getCopier(ModelBusChangeRecorderConverter changeManager){
	// if(changeManagerToCopierMap == null){
	// changeManagerToCopierMap = new HashMap<ModelBusChangeRecorderConverter, EcoreUtil.Copier>();
	//
	// }
	// if(!changeManagerToCopierMap.containsKey(changeManager)){
	// Copier copier = new Copier();
	// changeManagerToCopierMap.put(changeManager, copier);
	// }
	// return changeManagerToCopierMap.get(changeManager);
	// }

	private EObject copy(EObject eObject) {
		Copier copier = getCopier();
		EObject result = copier.copy(eObject);
		copier.copyReferences();
		return result;
	}

	// private EObject copy(EObject eObject,ModelBusChangeRecorderConverter changeManager){
	// Copier copier = getCopier(changeManager);
	// EObject result = copier.copy(eObject);
	// copier.copyReferences();
	// return result;
	// }

	public List<Notification> getRecordedNotifications() {
		if (recordedNotifications == null) {
			recordedNotifications = new ArrayList<Notification>();
		}
		return recordedNotifications;
	}

	// public List<Notification> getRecordedNotifications(ModelBusChangeRecorderConverter changeManager){
	// if(recordedNotificationsMap == null){
	// recordedNotificationsMap = new HashMap<ModelBusChangeRecorderConverter, List<Notification>>();
	//
	// }
	// if(!recordedNotificationsMap.containsKey(changeManager)){
	// List<Notification> recordedNotifications = new ArrayList<Notification>();
	// recordedNotificationsMap.put(changeManager, recordedNotifications);
	// }
	// return recordedNotificationsMap.get(changeManager);
	// }

	private Map<EObject, String> getEObjectToIDMap() {
		if (eObjetToIDMap == null) {
			eObjetToIDMap = new HashMap<EObject, String>();
		}
		return eObjetToIDMap;
	}

	// private Map<EObject, String> getEObjectToIDMap(ModelBusChangeRecorderConverter changeManager){
	// if(changeManagerToEObjetToIDMap == null){
	// changeManagerToEObjetToIDMap = new HashMap<ModelBusChangeRecorderConverter, Map<EObject,String>>();
	//
	// }
	// if(!changeManagerToEObjetToIDMap.containsKey(changeManager)){
	// HashMap<EObject, String> eObjetToIDMap = new HashMap<EObject, String>();
	// changeManagerToEObjetToIDMap.put(changeManager, eObjetToIDMap);
	// }
	// return changeManagerToEObjetToIDMap.get(changeManager);
	// }

	// public void recordNotification(Notification notification,ModelBusChangeRecorderConverter changeManager){
	// Object newValue = notification.getNewValue();
	// Object feature = notification.getFeature();
	// Object object = notification.getNotifier();
	// if(object instanceof EObject){
	// EObject notifier = (EObject)object;
	// if(!isContainedInTransientFeature(notifier) && !((EStructuralFeature)feature).isTransient()){
	// if(notification.getEventType() == Notification.ADD || notification.getEventType() == Notification.ADD_MANY){
	// if(newValue instanceof EObject){
	// copy((EObject)newValue,changeManager);
	// }else if(newValue instanceof EList){
	// for(Object obj : (EList)newValue){
	// if(obj instanceof EObject){
	// copy((EObject)obj,changeManager);
	// }
	// }
	// }
	// }
	// getRecordedNotifications(changeManager).add(notification);
	//
	// }
	// }else if(object instanceof Resource){
	// if(notification.getEventType() == Notification.ADD){
	// if(newValue instanceof EObject){
	// copy((EObject)newValue,changeManager);
	//
	// }
	// }
	// getRecordedNotifications(changeManager).add(notification);
	// }
	//
	// }

	public void recordNotification(Notification notification) {
		Object newValue = notification.getNewValue();
		Object feature = notification.getFeature();
		Object object = notification.getNotifier();
		if (object instanceof EObject) {
			EObject notifier = (EObject) object;
			if (!isContainedInTransientFeature(notifier) && !((EStructuralFeature) feature).isTransient()) {
				if (notification.getEventType() == Notification.ADD || notification.getEventType() == Notification.ADD_MANY) {
					if (newValue instanceof EObject) {
						copy((EObject) newValue);
					} else if (newValue instanceof EList) {
						for (Object obj : (EList) newValue) {
							if (obj instanceof EObject) {
								copy((EObject) obj);
							}
						}
					}
				}
				getRecordedNotifications().add(notification);

			}
		} else if (object instanceof Resource) {
			if (notification.getEventType() == Notification.ADD) {
				if (newValue instanceof EObject) {
					copy((EObject) newValue);

				}
			}
			getRecordedNotifications().add(notification);
		}

	}

	private boolean isContainedInTransientFeature(EObject eObject) {

		for (EObject container = eObject.eContainer(); container != null; container = eObject.eContainer()) {
			EStructuralFeature containingFeature = eObject.eContainingFeature();
			if (containingFeature.isTransient()) {
				return true;
			}
			eObject = container;
		}
		return false;

	}

	public List<Notification> stopRecordNotifications() {
		List<Notification> notifications = getRecordedNotifications();
		recordedNotifications = null;
		return notifications;
	}

	// public List<Notification> stopRecordNotifications(ModelBusChangeRecorderConverter changeManager){
	// List<Notification> notifications = getRecordedNotifications(changeManager);
	// this.recordedNotificationsMap.remove(changeManager);
	// return notifications;
	// }

	private EObject getCopy(EObject eObject) {
		Copier copier = getCopier();
		if (copier.containsKey(eObject)) {
			return copier.get(eObject);
		}
		return null;
	}

	// private EObject getCopy(EObject eObject,ModelBusChangeRecorderConverter changeManager){
	// Copier copier = getCopier(changeManager);
	// if(copier.containsKey(eObject)){
	// return copier.get(eObject);
	// }
	// return null;
	// }

	// get the copy of the direct or indirect container
	private EObject getContainerCopy(EObject eObject) {

		Copier copier = getCopier();
		EObject container = eObject.eContainer();

		while (container != null) {
			if (copier.containsKey(container)) {
				return copier.get(container);
			}
			container = container.eContainer();
		}
		return null;
	}

	// get the copy of the direct or indirect container
	// private EObject getContainerCopy(EObject eObject,ModelBusChangeRecorderConverter changeManager){
	//
	// Copier copier = getCopier(changeManager);
	// EObject container = eObject.eContainer();
	//
	// while(container != null){
	// if(copier.containsKey(container)){
	// return copier.get(container);
	// }
	// container = container.eContainer();
	// }
	// return null;
	// }

	public/* Map<String,EObject> */ChangeDescription convertNotificationsToChangeDescription(List<Notification> notifications) {
		// Map<String,EObject> changeDescriptionMap = null;
		ChangeDescription changeDescription = null;
		try {
			for (Notification notification : notifications) {
				Object notifier = notification.getNotifier();
				if (notifier instanceof EObject) {
					String localUri = null;
					Resource eObjectResource = ((EObject) notifier).eResource();
					if (eObjectResource != null) {
						localUri = eObjectResource.getURI().toString();
						// If the notifier's resource is local, its URI has to be changed to the remote one
						if (!URIUtil.isHTTPURI(localUri)) {
							String remoteUri = ChangeModelUtil.getRemoteModelUri(localUri);
							if (remoteUri != null) {
								eObjectResource.setURI((URI.createURI(remoteUri)));
								getResource2LocalUriMap().put(eObjectResource, localUri);
							}

						}
					}
					Object feature = notification.getFeature();
					if (feature instanceof EStructuralFeature) {
						handleFeatureChange((EStructuralFeature) feature, notification);

					}
				} else if (notifier instanceof Resource) {
					Resource resource = (Resource) notifier;
					// int featureID = notification.getFeatureID(Resource.class);
					// if(featureID == Resource.RESOURCE__CONTENTS && !((Resource.Internal)resource).isLoading()){
					String resourceURI = resource.getURI().toString();
					if (!URIUtil.isHTTPURI(resourceURI)) {
						String remoteUri = ChangeModelUtil.getRemoteModelUri(resourceURI);
						if (remoteUri != null) {
							resource.setURI((URI.createURI(remoteUri)));
							getResource2LocalUriMap().put(resource, resourceURI);
						}

					}
					handleResourceChange(notification);
					// }

				}
			}

			changeDescription = getChangeDescription();

			// analyzeListChanges(changeDescription);
			// changeDescriptionMap = getModelUriToChangeDescriptionMap();
			// changeDescription = getChangeDescription();

		} finally {
			// this.changeRecorder = null; //
			ModelBusChangeManager.getDomainToChangeManagerMap().remove(domain);
		}
		// return changeDescriptionMap;
		return changeDescription;

	}

	private void createListChanges(/* String notifierResourceUri, */EList<Object> newList, EList<?> oldList, EList<ListChange> listChanges/*
																																			 * new ,
																																			 * ModelBusChangeRecorderConverter
																																			 * changeManager
																																			 */) {
		int index = 0;
		for (Object oldObject : oldList) {
			if (newList.size() <= index) {
				// new
				ListChange listChange = createREMOVEListChange(index);// createADDListChange(/*notifierResourceUri,*/index,oldObject);
				// ListChange listChange = createADDListChange(/*notifierResourceUri,*/index,newObject,changeManager);
				// new
				listChanges.add(listChange);
			} else {
				boolean done;
				do {
					done = true;
					Object targetObject = newList.get(index);
					if (targetObject == null ? oldObject != null : !targetObject.equals(oldObject)) {
						int position = ECollections.indexOf(newList, oldObject, index);
						if (position != -1) {
							int targetIndex = ECollections.indexOf(oldList, targetObject, index);
							if (targetIndex == -1) {
								ListChange listChange = createADDListChange(index, targetObject);// createREMOVEListChange(index);
								listChanges.add(listChange);
								newList.remove(index);
								done = false;
							} else if (/* targetIndex > position */position > targetIndex) {
								if (newList.size() <= /* targetIndex */position) {
									/* targetIndex */position = newList.size() - 1;
								}
								ListChange listChange = createMOVEListChange(/* index, targetIndex */index, position);
								listChanges.add(listChange);
								newList.move(index, position);
								done = false;
							} else {
								if (index != targetIndex) {
									ListChange listChange = createMOVEListChange(/* position,index */index, targetIndex);
									listChanges.add(listChange);
								}
								// newList.move(index, targetIndex);
								// done = false;
							}
						} else {

							// new
							ListChange listChange = createREMOVEListChange(index);// createADDListChange(/*notifierResourceUri,*/index,oldObject);

							// ListChange listChange = createADDListChange(/*notifierResourceUri,*/index,newObject,changeManager);
							// new
							listChanges.add(listChange);
							newList.add(index, oldList.get(index));
							done = false;
						}
					}
				} while (!done);
			}
			++index;
		}
		for (int i = newList.size(); i > index;) {
			i--;
			Object object = newList.get(i);
			int ind = oldList.indexOf(object);
			if (ind == -1) {
				ListChange listChange = createADDListChange(i, newList.get(i));// createREMOVEListChange(i);
				listChanges.add(listChange);
			}
		}
	}

	public Map<Resource, String> getResource2LocalUriMap() {
		// TODO Auto-generated method stub
		if (resourceToUriMap == null) {
			resourceToUriMap = new HashMap<Resource, String>();
		}
		return resourceToUriMap;
	}

	// public Map<Resource, String> getResource2LocalUriMap(ModelBusChangeRecorderConverter changeManager) {
	// // TODO Auto-generated method stub
	// if(changeManagerToResourceToUriMap == null){
	// changeManagerToResourceToUriMap = new HashMap<ModelBusChangeRecorderConverter, Map<Resource,String>>();
	//
	// }
	// if(!changeManagerToResourceToUriMap.containsKey(changeManager)){
	// HashMap<Resource, String> resourceToUriMap = new HashMap<Resource, String>();
	// changeManagerToResourceToUriMap.put(changeManager, resourceToUriMap);
	// }
	// return changeManagerToResourceToUriMap.get(changeManager);
	// }

	private void adjustObjectChanges(ChangeDescription changeDescription) {

		EList<EObject> objectsToattach = changeDescription.getObjectsToAttach();
		EMap<EObject, EList<FeatureChange>> objectChanges = changeDescription.getObjectChanges();
		EMap<EObject, EList<FeatureChange>> changedObjectChanges = new BasicEMap<EObject, EList<FeatureChange>>(objectChanges.map());

		for (Map.Entry<EObject, EList<FeatureChange>> entry : objectChanges) {
			EObject key = entry.getKey();
			EList<FeatureChange> featureChangeValue = entry.getValue();
			if (objectsToattach.contains(key)) {

				for (Map.Entry<EObject, EList<FeatureChange>> entry2 : objectChanges) {
					EObject key2 = entry2.getKey();
					if (!key.equals(key2)) {
						EList<FeatureChange> featureChanges = entry2.getValue();
						for (FeatureChange featureChange : featureChanges) {
							EList<ListChange> listChanges = featureChange.getListChanges();
							for (ListChange listChange : listChanges) {
								EList<EObject> referenceValues = listChange.getReferenceValues();
								for (EObject value : referenceValues) {

									if (key.equals(value)) {
										EObject newKey = EcoreUtil.copy(key);
										String fragment = EcoreUtil.getURI(key).fragment();
										URI resourceuri = EcoreUtil.getURI(key2).trimFragment();
										if (resourceuri != null && !resourceuri.toString().isEmpty()
												&& !resourceuri.toString().equals("tempResource")) {
											URI uri = resourceuri.appendFragment(fragment);
											((InternalEObject) newKey).eSetProxyURI(uri);
											changedObjectChanges.removeKey(key);
											changedObjectChanges.put(newKey, featureChangeValue);
											break;
										}
									}

								}
							}

						}
					}
				}

			}
		}

		objectChanges.clear();
		objectChanges.putAll(changedObjectChanges);

	}

	private void setIDs(Resource tempResource, ChangeDescription changeDescription) {

		EList<EObject> objectsToattach = changeDescription.getObjectsToAttach();
		for (EObject objectToAttach : objectsToattach) {
			Map<EObject, String> objectToIDMap = getEObjectToIDMap();
			for (Iterator<EObject> iterator = EcoreUtil.getAllContents(objectToAttach, true); iterator.hasNext();) {
				EObject contentObject = iterator.next();
				String id = objectToIDMap.get(contentObject);
				if (id != null) {
					((XMIResource) tempResource).setID(contentObject, id);
				}
			}
			String objectID = objectToIDMap.get(objectToAttach);
			if (objectID != null) {
				((XMIResource) tempResource).setID(objectToAttach, objectID);
			}
		}

	}

	public String eObjectToString(EObject eObject) {

		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("*", new XMIResourceFactoryImpl());
		Resource tempResource = resourceSet.createResource(URI.createURI("tempResource"));
		tempResource.getContents().add(eObject);

		setIDs(tempResource, (ChangeDescription) eObject);

		adjustObjectChanges((ChangeDescription) eObject);

		ByteArrayOutputStream output = new ByteArrayOutputStream();

		try {
			tempResource.save(output, Collections.EMPTY_MAP);
			System.out.println("ChangeRecorder: ChangeDescription: " + output.toString());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return output.toString();

	}

	// public String eObjectToString(EObject eObject,ModelBusChangeRecorderConverter changeManager){
	//
	// // if(eObject.eContents().isEmpty()){
	// // return null;
	// // }
	//
	// ResourceSet resourceSet = new ResourceSetImpl();
	// resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("*", new XMIResourceFactoryImpl());
	// Resource tempResource = resourceSet.createResource(URI.createURI("tempResource"));
	// tempResource.getContents().add(eObject);
	// EList<EObject> objectsToattach = ((ChangeDescription)eObject).getObjectsToAttach();
	// for (EObject objectToAttach : objectsToattach) {
	// Map<EObject,String> objectToIDMap = getEObjectToIDMap(changeManager);
	// for(Iterator<EObject> iterator = EcoreUtil.getAllContents(objectToAttach, true);iterator.hasNext();){
	// EObject contentObject = iterator.next();
	// String id = objectToIDMap.get(contentObject);
	// if(id != null){
	// ((XMIResource)tempResource).setID(contentObject, id);
	// }
	// }
	// String objectID = objectToIDMap.get(objectToAttach);
	// if(objectID != null){
	// ((XMIResource)tempResource).setID(objectToAttach, objectID);
	// }
	// }
	//
	// ByteArrayOutputStream output = new ByteArrayOutputStream();
	// // Map<String,Boolean> options = new HashMap<String, Boolean>();
	// // options.put(XMIResource.OPTION_PROCESS_DANGLING_HREF_DISCARD, Boolean.TRUE);
	//
	// try {
	// tempResource.save(output,Collections.EMPTY_MAP);
	// // System.out.println("commit: " + Activator.MESSAGE_ID);
	// System.out.println("ChangeDescription: " + output.toString());
	// }catch (IOException e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	//
	// return output.toString();
	//
	// }

	// If the eObject to change do not have an ID and the fragment segment do not start with '//@' (in the case of named EClassifiers or
	// EAnnotations),
	// the fragment segment has to be converted and the proxy URI of the eObject is set to the new URI.
	private EList<FeatureChange> getFeatureChanges(EObject eObject/* new ,ModelBusChangeRecorderConverter changeManager */) {

		Resource resource = eObject.eResource();
		String fragment = EcoreUtil.getURI(eObject).fragment();
		String id = ((XMIResource) resource).getID(eObject);
		// ChangeDescription changeDescription = getChangeDescriptionFor(uri.toString());

		// new
		ChangeDescription changeDescription = getChangeDescription();
		// ChangeDescription changeDescription = getChangeDescription(changeManager);
		// new

		// new
		EObject copy = getCopy(eObject);
		// EObject copy = getCopy(eObject, changeManager);
		// new

		if (copy != null && /* new !getObjectsToAttach(changeManager).contains(copy) */!getObjectsToAttach().contains(copy)) {
			eObject = copy;
		}
		EList<FeatureChange> changes = changeDescription.getObjectChanges().get(eObject);
		if (changes == null) {
			if (id == null && fragment != null && !fragment.equals("/")
					&& (!fragment.startsWith("//@") || fragment.charAt(fragment.lastIndexOf("/") + 1) != '@')) {
				// new
				EObject copyEObject = copy(eObject);
				// EObject copyEObject = copy(eObject, changeManager);
				// new
				handleUri(eObject, copyEObject);
				eObject = copyEObject;
			}
			Map.Entry<EObject, EList<FeatureChange>> entry = ChangeFactory.eINSTANCE.createEObjectToChangesMapEntry(eObject);
			changeDescription.getObjectChanges().add(entry);
			changes = entry.getValue();
		}
		return changes;
	}

	// check whether there are any references to local resources; change resource URI to remote URI
	private void handleObjectToAttach(EObject eObject/* new ,ModelBusChangeRecorderConverter changeManager */) {

		Map<EObject, Collection<Setting>> crossReferencesMap = EcoreUtil.CrossReferencer.find(Collections.singletonList(eObject));
		for (Iterator<Map.Entry<EObject, Collection<Setting>>> iterator = crossReferencesMap.entrySet().iterator(); iterator.hasNext();) {
			Map.Entry<EObject, Collection<Setting>> entry = iterator.next();
			EObject key = entry.getKey();
			Resource resource = key.eResource();
			if (resource != null) {
				String localUri = resource.getURI().toString();
				if (!URIUtil.isHTTPURI(localUri)) {
					String remoteUri = ChangeModelUtil.getRemoteModelUri(localUri);
					if (remoteUri != null) {
						resource.setURI(URI.createURI(remoteUri));
						// new
						getResource2LocalUriMap().put(resource, localUri);
						// getResource2LocalUriMap(changeManager).put(resource, localUri);
						// new
					}
				}
			}
		}

	}

	private void handleUri(EObject eobject, EObject copyObject) {

		URI uri = eobject.eResource().getURI();
		List<String> uriFragmentPath = new ArrayList<String>();
		for (EObject container = eobject.eContainer(); container != null; container = eobject.eContainer()) {
			EStructuralFeature containingFeature = eobject.eContainingFeature();
			String uriFragment = getURIFragment(containingFeature, eobject);
			if (uriFragment.isEmpty()) {
				uriFragmentPath.clear();
				break;
			}
			uriFragmentPath.add(uriFragment);
			eobject = container;
		}

		if (!uriFragmentPath.isEmpty()) {
			StringBuilder resultFragmentPath = new StringBuilder();
			resultFragmentPath.append("/");

			for (int i = uriFragmentPath.size() - 1; i >= 0; i--) {
				resultFragmentPath.append("/");
				resultFragmentPath.append(uriFragmentPath.get(i));
			}

			String fragment = resultFragmentPath.toString();

			((InternalEObject) copyObject).eSetProxyURI(uri.appendFragment(fragment));
			// System.out.println("set proxyURI: " + uri.appendFragment(fragment));
		} else {

			((InternalEObject) copyObject).eSetProxyURI(EcoreUtil.getURI(eobject));
			// System.out.println("set proxyURI: " + EcoreUtil.getURI(eobject));
		}

	}

	private String getURIFragment(EStructuralFeature feature, EObject eObject) {
		EObject container = eObject.eContainer();
		StringBuilder result = new StringBuilder();
		result.append('@');
		result.append(feature.getName());
		if (feature instanceof EReference && feature.isMany()) {
			result.append(".");
			EList<?> featureValue = (EList<?>) container.eGet(feature);
			int index = featureValue.indexOf(eObject);
			result.append(index);
		}
		return result.toString();
	}

	// If a copy of the notifier or a copy of the notifier's direct or indirect container exists,
	// it has to be checked whether the feature to change is already set in the copied element. In this case
	// the feature has to be unset or set to the old value.
	private void handleCopy(EObject notifier, Notification notification/* new ,ModelBusChangeRecorderConverter changeManager */) {

		// new
		EObject copiedObject = getCopy(notifier);
		EObject copiedContainer = getContainerCopy(notifier);
		// EObject copiedObject = getCopy(notifier, changeManager);
		// EObject copiedContainer = getContainerCopy(notifier, changeManager);
		// new
		EStructuralFeature feature = (EStructuralFeature) notification.getFeature();
		// Object oldValue = notification.getOldValue();
		// if(oldValue instanceof EObject){
		// oldValue = EcoreUtil.copy((EObject)oldValue);
		// }else if(oldValue instanceof List<?>){
		// for(Object object : (List<?>)oldValue){
		// if(object instanceof EObject){
		// object = EcoreUtil.copy((EObject)object);
		// }
		//
		// }
		// }

		if (copiedObject != null) {
			if (!feature.isUnsettable() && copiedObject.eIsSet(feature)) {
				// if(oldValue != null){
				// copiedObject.eSet(feature, oldValue);
				// }else{
				copiedObject.eUnset(feature);
				// }
			}

		} else if (copiedContainer != null) {
			EObject notifierInCopiedObject = null;
			EStructuralFeature containingFeature = notifier.eContainingFeature();
			EObject originalContainer = notifier.eContainer();
			Object featureValue = originalContainer.eGet(containingFeature);
			if (copiedContainer.eIsSet(containingFeature)) {
				int index = -1;
				if (featureValue instanceof List<?>) {
					index = ((List<?>) featureValue).indexOf(notifier);
				}
				if (index == -1) {
					notifierInCopiedObject = (EObject) copiedContainer.eGet(containingFeature);
				} else {
					notifierInCopiedObject = (EObject) ((List<?>) copiedContainer.eGet(containingFeature)).get(index);
				}
				if (notifierInCopiedObject != null) {
					// if(oldValue != null){
					// notifierInCopiedObject.eSet(feature, oldValue);
					// }else{
					notifierInCopiedObject.eUnset(feature);
					// }
				}
			} else {
				// new
				EObject notifierCopy = copy(notifier);
				// EObject notifierCopy = copy(notifier, changeManager);
				// new
				if (!feature.isUnsettable()) {
					// if(oldValue != null){
					// notifierCopy.eSet(feature, oldValue);
					// }else{
					notifierCopy.eUnset(feature);
					// }
				}
				Object newValue = notifierCopy;
				if (feature.isMany()) {
					newValue = Collections.singletonList(notifierCopy);
				}
				copiedContainer.eSet(containingFeature, newValue);
			}

		}

	}

	private EList<ResourceChange> getResourceChanges() {
		return getChangeDescription().getResourceChanges();
	}

	// private EList<ResourceChange> getResourceChanges(ModelBusChangeRecorderConverter changeManager){
	// return getChangeDescription(changeManager).getResourceChanges();
	// }

	private ResourceChange getResourceChange(Resource resource) {
		// String resourceUri = resource.getURI().toString();
		// List<ResourceChange> resourceChanges = getResourceChanges(resourceUri);
		List<ResourceChange> resourceChanges = getResourceChanges();
		for (int i = 0; i < resourceChanges.size(); i++) {
			ResourceChange resourceChange = resourceChanges.get(i);
			if (resourceChange.getResource() == resource) {
				return resourceChange;
			}
		}
		return null;
	}

	// private ResourceChange getResourceChange(Resource resource,ModelBusChangeRecorderConverter changeManager){
	// // String resourceUri = resource.getURI().toString();
	// // List<ResourceChange> resourceChanges = getResourceChanges(resourceUri);
	// List<ResourceChange> resourceChanges = getResourceChanges(changeManager);
	// for (int i = 0; i < resourceChanges.size(); i++){
	// ResourceChange resourceChange = resourceChanges.get(i);
	// if (resourceChange.getResource() == resource){
	// return resourceChange;
	// }
	// }
	// return null;
	// }

	private FeatureChange getFeatureChange(List<FeatureChange> changes, EStructuralFeature feature) {
		for (FeatureChange featureChange : changes) {
			if (featureChange.getFeature() == feature) {
				return featureChange;
			}
		}
		return null;
	}

	private void handleResourceChange(Notification notification/* new ,ModelBusChangeRecorderConverter changeManager */) {
		Resource resource = (Resource) notification.getNotifier();
		// new
		ResourceChange resourceChange = getResourceChange(resource);
		List<ResourceChange> resourceChanges = getResourceChanges();
		// ResourceChange resourceChange = getResourceChange(resource,changeManager);
		// List<ResourceChange> resourceChanges = getResourceChanges(changeManager);
		// new
		Object notificationNewValue = notification.getNewValue();
		int position = notification.getPosition();
		switch (notification.getEventType()) {
			case Notification.ADD: {

				if (resource != null && resourceChanges != null) {
					EList<Object> oldValue = new BasicEList<Object>(resource.getContents());
					EList<Object> newList = new BasicEList<Object>(resource.getContents());
					oldValue.remove(position);
					if (resourceChange != null) {
						oldValue = new BasicEList<Object>(resourceChange.getValue());
						oldValue.remove(notificationNewValue);
						resourceChanges.remove(resourceChange);
					}
					resourceChange = ChangeFactory.eINSTANCE.createResourceChange(resource, oldValue);
					resourceChanges.add(resourceChange);
					EList<ListChange> listChanges = resourceChange.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges(newList, oldValue, listChanges,changeManager);
					// new
				}

				break;
			}

			case Notification.REMOVE: {

				if (resource != null && resourceChanges != null) {
					EList<Object> oldValue = new BasicEList<Object>(resource.getContents());
					EList<Object> newList = new BasicEList<Object>(resource.getContents());
					if (position == Notification.NO_INDEX) {
						position = 0;
					}
					if (resourceChange != null) {
						oldValue = new BasicEList<Object>((Collection<?>) resourceChange.getValue());
						resourceChanges.remove(resourceChange);
					}
					if (position <= oldValue.size()) {
						oldValue.add(position, notification.getOldValue());
					} else {
						oldValue.add(notification.getOldValue());
					}
					resourceChange = ChangeFactory.eINSTANCE.createResourceChange(resource, oldValue);
					resourceChanges.add(resourceChange);
					EList<ListChange> listChanges = resourceChange.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges(newList, oldValue, listChanges,changeManager);
					// new
				}
				break;

			}

		}
	}

	private void handleFeatureChange(EStructuralFeature feature, Notification notification/* new ,ModelBusChangeRecorderConverter changeManager */) {

		EObject notifier = (EObject) notification.getNotifier();

		int position = notification.getPosition();
		Object notificationNewValue = notification.getNewValue();

		Object newValue = null;
		Resource notifierResource = notifier.eResource();
		if (notifierResource == null) {
			return;
		}
		// new
		handleCopy(notifier, notification);
		// handleCopy(notifier, notification,changeManager);
		// new

		EList<FeatureChange> changes = getFeatureChanges(notifier/* new ,changeManager */);
		FeatureChange change = getFeatureChange(changes, feature);
		boolean set = notification.wasSet();
		switch (notification.getEventType()) {
			case Notification.SET:
			case Notification.UNSET: {
				if (change != null && changes != null) {
					changes.remove(change);
				}
				if (changes != null) {
					EObject newEObject = null;
					if (feature.isMany()) {
						newValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
						Object newValueObject = ((EList<Object>) newValue).get(position);
						if (newValueObject instanceof EObject) {
							newEObject = (EObject) newValueObject;
						}

					} else {
						newValue = notificationNewValue;
						if (newValue instanceof EObject) {
							newEObject = (EObject) newValue;
						}

					}

					// If the new value is an instance of EObject and is contained in the notifier itself,
					// the new value has to be copied and added to the objectsToAttach list
					if (newEObject != null) {
						if (notifier.equals(newEObject.eContainer())) {
							// new
							Copier copier = getCopier();
							// Copier copier = getCopier(changeManager);
							// new
							EObject newEObjectCopy = copier.get(newEObject);
							if (newEObjectCopy == null) {
								// new
								newEObjectCopy = copy(newEObject);
								// newEObjectCopy = copy(newEObject,changeManager);
								// new

							}
							// List<EObject> objectsToAttach = getObjectsToAttachFor(notifierResource.getURI().toString());
							// new
							List<EObject> objectsToAttach = getObjectsToAttach();
							// List<EObject> objectsToAttach = getObjectsToAttach(changeManager);
							// new
							if (!objectsToAttach.contains(newEObjectCopy)) {
								// new
								handleObjectToAttach(newEObjectCopy);
								fillEObjectToIDMap(Collections.singletonList(newEObject), Collections.singletonList(newEObjectCopy));
								// handleObjectToAttach(newEObjectCopy,changeManager);
								// fillEObjectToIDMap(Collections.singletonList(newEObject), Collections.singletonList(newEObjectCopy),changeManager);
								// new
								objectsToAttach.add(newEObjectCopy);
								// ChangeDescription changeDescription = getChangeDescriptionFor(notifierResource.getURI().toString());
								// new
								ChangeDescription changeDescription = getChangeDescription();
								// ChangeDescription changeDescription = getChangeDescription(changeManager);
								// new
								((ChangeDescriptionImpl) changeDescription)
										.eSet(ChangePackage.CHANGE_DESCRIPTION__OBJECTS_TO_ATTACH, objectsToAttach);
							}
							if (newValue instanceof EList<?>) {
								((EList<Object>) newValue).remove(position);
								((EList<Object>) newValue).add(position, newEObjectCopy);
							} else {
								newValue = newEObjectCopy;
							}
						}
					}
				}

				change = createFeatureChange(feature, newValue, set);
				EObject referenceValue = change.getReferenceValue();
				if (referenceValue != null) {

					Resource resource = referenceValue.eResource();
					if (resource != null) {
						String localUri = resource.getURI().toString();
						if (!URIUtil.isHTTPURI(localUri)) {
							String remoteUri = ChangeModelUtil.getRemoteModelUri(localUri);
							if (remoteUri != null) {
								resource.setURI(URI.createURI(remoteUri));
								// new
								getResource2LocalUriMap().put(resource, localUri);
								// getResource2LocalUriMap(changeManager).put(resource, localUri);
								// new
							}

						}

						// String id = ((XMIResource)resource).getID(referenceValue);
						// String fragment = resource.getURIFragment(referenceValue);
						//
						// if(/*referenceValue instanceof EModelElement &&*/ id == null && fragment != null && !fragment.equals("/") &&
						// !fragment.startsWith("//@")/*fragment.charAt(fragment.lastIndexOf("/")+1) != '@'*/){
						// Copier copier = getCopier();
						// EObject copyEObject = copier.copy(referenceValue);
						// copier.copyReferences();
						// handleUri(referenceValue, copyEObject);
						// change = createFeatureChange(feature, copyEObject, set);
						// }

					}
				}
				changes.add(change);
				break;

				// }

			}

			case Notification.REMOVE: {
				// if(change != null && changes != null){
				// changes.remove(change);
				// }
				if (changes != null) {
					EList<Object> oldValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					EList<Object> newList = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					if (position == Notification.NO_INDEX) {
						position = 0;
					}
					// oldValue.add(position, notification.getOldValue());
					if (change != null) {
						oldValue = new BasicEList<Object>((Collection<?>) getFeatureChangeToOldValueMap().get(change));
						// oldValue = new BasicEList<Object>((Collection<?>)change.getValue());
						// changes.remove(change);
					}

					if (position <= oldValue.size()) {
						oldValue.add(position, notification.getOldValue());
					} else {
						oldValue.add(notification.getOldValue());
					}

					if (change == null) {
						change = createFeatureChange(feature, /* oldValue */newValue, set);
					}
					getFeatureChangeToOldValueMap().put(change, oldValue);
					// newValue = new BasicEList<Object>((Collection<?>)notifier.eGet(feature));
					// change = createFeatureChange(feature, newValue, set);
					changes.add(change);
					EList<ListChange> listChanges = change.getListChanges();
					listChanges.clear();
					// String eObjectResourceUri = eObject.eResource().getURI().toString();
					// new
					createListChanges(/* eObjectResourceUri, */newList, oldValue, listChanges);
					// createListChanges(/*eObjectResourceUri,*/ newList, oldValue, listChanges,changeManager);
					// new
				}
				// EList<ListChange> listChanges = change.getListChanges();
				// ListChange listChange = createREMOVEListChange(position/*, ChangeKind.REMOVE_LITERAL, null*/);
				// listChanges.add(listChange);
				break;

			}
			case Notification.REMOVE_MANY: {

				if (changes != null) {
					List<Object> removedValues = (List<Object>) notification.getOldValue();
					EList<Object> oldValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					EList<Object> newList = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					if (change != null) {
						oldValue = new BasicEList<Object>((Collection<?>) getFeatureChangeToOldValueMap().get(change));
						// oldValue = new BasicEList<Object>((Collection<?>)change.getValue());
						// changes.remove(change);
					}
					int[] positions = (int[]) notification.getNewValue();
					if (positions == null) {
						oldValue.addAll(removedValues);
					} else {
						for (int i = 0; i < positions.length; ++i) {
							oldValue.add(positions[i], removedValues.get(i));
						}
					}

					if (change == null) {
						change = createFeatureChange(feature, /* oldValue */newValue, set);
					}
					getFeatureChangeToOldValueMap().put(change, oldValue);
					changes.add(change);
					EList<ListChange> listChanges = change.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges(newList, oldValue, listChanges,changeManager);
					// new
				}
				break;
			}

			case Notification.ADD_MANY: {

				if (changes != null) {

					EList<Object> oldValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					EList<Object> newList = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					for (int i = ((Collection<?>) notification.getNewValue()).size(); --i >= 0;) {
						oldValue.remove(position);
					}
					if (change != null) {
						oldValue = new BasicEList<Object>((Collection<?>) getFeatureChangeToOldValueMap().get(change));
						// oldValue = new BasicEList<Object>((Collection<?>)change.getValue());
						oldValue.removeAll((Collection<?>) notification.getNewValue());
						// changes.remove(change);
					}

					if (change == null) {
						change = createFeatureChange(feature, /* oldValue */newValue, set);
					}
					getFeatureChangeToOldValueMap().put(change, oldValue);
					EObject referenceValue = change.getReferenceValue();
					if (referenceValue != null) {
						Resource resource = referenceValue.eResource();
						if (resource != null) {
							String localUri = resource.getURI().toString();
							if (!URIUtil.isHTTPURI(localUri)) {
								String remoteUri = ChangeModelUtil.getRemoteModelUri(localUri);
								if (remoteUri != null) {
									resource.setURI(URI.createURI(remoteUri));
									// new
									getResource2LocalUriMap().put(resource, localUri);
									// getResource2LocalUriMap(changeManager).put(resource, localUri);
									// new
								}
							}
						}
					}
					changes.add(change);
					EList<ListChange> listChanges = change.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges( newList, oldValue, listChanges,changeManager);
					// new
				}

			}
			case Notification.ADD: {

				if (changes != null) {
					EList<Object> oldValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					EList<Object> newList = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					if (position >= oldValue.size()) {
						position = oldValue.size() - 1;
					}
					oldValue.remove(position);
					if (change != null) {
						oldValue = new BasicEList<Object>((Collection<?>) getFeatureChangeToOldValueMap().get(change));
						// oldValue = new BasicEList<Object>((Collection<?>)change.getValue());
						oldValue.remove(notification.getNewValue());
						// changes.remove(change);
					}

					if (change == null) {
						change = createFeatureChange(feature, /* oldValue */newValue, set);
					}
					getFeatureChangeToOldValueMap().put(change, oldValue);
					EObject referenceValue = change.getReferenceValue();
					if (referenceValue != null) {
						Resource resource = referenceValue.eResource();
						if (resource != null) {
							String localUri = resource.getURI().toString();
							if (!URIUtil.isHTTPURI(localUri)) {
								String remoteUri = ChangeModelUtil.getRemoteModelUri(localUri);
								if (remoteUri != null) {
									resource.setURI(URI.createURI(remoteUri));
									// new
									getResource2LocalUriMap().put(resource, localUri);
									// getResource2LocalUriMap(changeManager).put(resource, localUri);
									// new
								}
							}
						}
					}

					changes.add(change);
					EList<ListChange> listChanges = change.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges(newList, oldValue, listChanges,changeManager);
					// new
				}
				break;

			}

			case Notification.MOVE: {
				if (changes != null) {
					EList<Object> oldValue = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					EList<Object> newList = new BasicEList<Object>((Collection<?>) notifier.eGet(feature));
					int oldPosition = (Integer) notification.getOldValue();
					int newPosition = position;
					Object movedObject = oldValue.get(newPosition);
					oldValue.move(oldPosition, newPosition);
					if (change != null) {
						oldValue = new BasicEList<Object>((Collection<?>) getFeatureChangeToOldValueMap().get(change));
						// oldValue = new BasicEList<Object>((Collection<?>)change.getValue());
						oldValue.move(oldPosition, movedObject);
						// changes.remove(change);
					}

					if (change == null) {
						change = createFeatureChange(feature, newValue, set);
					}
					getFeatureChangeToOldValueMap().put(change, oldValue);
					changes.add(change);
					EList<ListChange> listChanges = change.getListChanges();
					listChanges.clear();
					// new
					createListChanges(newList, oldValue, listChanges);
					// createListChanges(newList, oldValue, listChanges,changeManager);
					// new
				}
				break;
			}

			default:
				break;
		}
	}

	private ListChange createREMOVEListChange(int index) {
		ListChange listChange = ChangeFactory.eINSTANCE.createListChange();
		listChange.setIndex(index);
		listChange.setKind(ChangeKind.REMOVE_LITERAL);

		return listChange;
	}

	private ListChange createMOVEListChange(int index, int moveToIndex) {
		ListChange listChange = ChangeFactory.eINSTANCE.createListChange();
		listChange.setIndex(index);
		listChange.setMoveToIndex(moveToIndex);
		listChange.setKind(ChangeKind.MOVE_LITERAL);

		return listChange;
	}

	private void fillEObjectToIDMap(List<?> original, List<?> copyObject/* new , ModelBusChangeRecorderConverter changeManager */) {
		// new
		Copier copier = getCopier();
		// Copier copier = getCopier(changeManager);
		// new

		for (Object object : original) {
			if (object instanceof EObject) {
				EObject eObject = (EObject) object;
				Resource resource = eObject.eResource();
				String eObjectID = null;
				if (resource != null) {
					eObjectID = ((XMIResource) (eObject).eResource()).getID((eObject));

					for (Iterator iterator = EcoreUtil.getAllContents(eObject, true); iterator.hasNext();) {
						EObject contentObject = (EObject) iterator.next();
						EObject contentCopyObject = copier.get(contentObject);
						// if(!(contentObject instanceof EStructuralFeature)){
						String id = ((XMIResource) contentObject.eResource()).getID(contentObject);
						if (id != null) {
							// new
							getEObjectToIDMap().put(contentCopyObject, id);
							// getEObjectToIDMap(changeManager).put(contentCopyObject, id);
							// new
						}
						// }
					}
				}
				if (eObjectID != null) {
					int position = original.indexOf(eObject);
					// new
					getEObjectToIDMap().put((EObject) copyObject.get(position), eObjectID);
					// getEObjectToIDMap(changeManager).put((EObject) copyObject.get(position), eObjectID);
					// new
				}
			}
		}

	}

	private ListChange createADDListChange(/* String notifierResourceUri, */int index, /* ChangeKind kind, */Object newValue/*
																															 * new ,
																															 * ModelBusChangeRecorderConverter
																															 * changeManager
																															 */) {
		// new
		Copier copier = getCopier();
		// Copier copier = getCopier(changeManager);
		// new
		// EObject copyObject = copier.get(newValue);//copiedEObjects.get(newValue);
		EList<Object> copyObject = new BasicEList<Object>();
		EList<Object> originalObject = new BasicEList<Object>();
		if (newValue instanceof EObject) {
			// copyObject = copier.get(newValue);
			EObject copy = copier.get(newValue);
			if (copy != null) {
				originalObject.add((EObject) newValue);
				copyObject.add(copy);
			}
		} else if (newValue instanceof Collection) {
			// copyObject = new BasicEList<EObject>();
			for (Object obj : (Collection<?>) newValue) {
				if (obj instanceof EObject) {
					EObject copy = copier.get(obj);
					// originalObject.add((EObject)obj);
					copyObject.add(copy);
					// ((EList<EObject>)copyObject).add(copy);
				} else {
					copyObject.add(obj);
				}
				originalObject.add(obj);
			}
		}
		// fillEObjectToIDMap(newValue, copyObject);
		// new
		fillEObjectToIDMap(originalObject, copyObject);
		List<EObject> objectsToAttach = getObjectsToAttach();
		// fillEObjectToIDMap(originalObject, copyObject,changeManager);
		// List<EObject> objectsToAttach = getObjectsToAttach(changeManager);
		// new
		ListChange listChange = ChangeFactory.eINSTANCE.createListChange();
		// new
		ChangeDescription changeDescription = getChangeDescription();
		// ChangeDescription changeDescription = getChangeDescription(changeManager);
		// new

		for (Object object : copyObject) {
			if (object instanceof EObject) {
				EObject copyEObject = (EObject) object;
				if (!objectsToAttach.contains(copyEObject)) {
					// new
					handleObjectToAttach(copyEObject);
					// handleObjectToAttach(copyEObject,changeManager);
					// new
					objectsToAttach.add(copyEObject);
					// objectsToAttach.addAll(copyObject);
					((ChangeDescriptionImpl) changeDescription).eSet(ChangePackage.CHANGE_DESCRIPTION__OBJECTS_TO_ATTACH, objectsToAttach);
				}
			}
		}

		listChange.getValues().addAll(copyObject);
		listChange.setIndex(index);
		listChange.setKind(ChangeKind.ADD_LITERAL);
		return listChange;

	}

	private FeatureChange createFeatureChange(EStructuralFeature feature, Object value, boolean wasSet) {
		FeatureChange featureChange = null;
		if (value != null) {
			featureChange = ChangeFactory.eINSTANCE.createFeatureChange(feature, value, wasSet);
		} else {
			featureChange = ChangeFactory.eINSTANCE.createFeatureChange();
			featureChange.setFeature(feature);
		}
		return featureChange;
	}

}
