package org.modelbus.team.eclipse.changemodelnotification.listener;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IExecutionListener;
import org.eclipse.core.commands.NotHandledException;
import org.eclipse.core.resources.IFile;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.domain.IEditingDomainProvider;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.parts.IDiagramEditorInput;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.IPathEditorInput;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory;
import org.modelbus.team.eclipse.changemodelnotification.util.ChangeModelUtil;

public class ModelBusExcecutionListener implements IExecutionListener {

	private ModelbusChangeModelResourceSetListener	modelbusChangeModelResourceSetListener;
	private TransactionalEditingDomain				domain;

	public ModelBusExcecutionListener(ModelbusChangeModelResourceSetListener modelbusChangeModelResourceSetListener, TransactionalEditingDomain domain) {
		this.modelbusChangeModelResourceSetListener = modelbusChangeModelResourceSetListener;
		this.domain = domain;
	}

	@Override
	public void notHandled(String commandId, NotHandledException exception) {
		// TODO Auto-generated method stub

	}

	@Override
	public void postExecuteFailure(String commandId, ExecutionException exception) {
		// TODO Auto-generated method stub

	}

	@Override
	public void postExecuteSuccess(String commandId, Object returnValue) {
		// TODO Auto-generated method stub
		if (commandId.equals(ActionFactory.SAVE.getCommandId()) || commandId.equals(ActionFactory.SAVE_ALL.getCommandId())
				|| commandId.equals(ActionFactory.SAVE_AS.getCommandId())) {
			// ModelbusChangeModelResourceSetListener modelbusChangeModelResourceSetListener =
			// ModelbusChangeModelResourceSetListener.getModelBusChangeModelResourceSetListener();
			if (modelbusChangeModelResourceSetListener != null) {
				try {
					IEditorPart editorPart = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor();
					if (editorPart != null) {
						Object adapter = editorPart.getAdapter(IEditingDomainProvider.class);
						if (adapter instanceof IEditingDomainProvider) {
							IEditingDomainProvider domainProvider = (IEditingDomainProvider) adapter;
							EditingDomain domain = domainProvider.getEditingDomain();
							if (domain instanceof TransactionalEditingDomain) {
								IEditorInput input = editorPart.getEditorInput();
								String remotePath = null;
								String localPath = null;
								if (input instanceof IPathEditorInput/* IFileEditorInput */) {
									localPath = "file:/" + ((/* IFileEditorInput */IPathEditorInput) input).getPath().toString();// .getFile().getLocation().toString();
									// remotePath = ChangeModelUtil.getRemoteModelUri(localPath);
									// System.out.println();
								} else if (input instanceof IDiagramEditorInput) {
									IFile file = (IFile) ((IDiagramEditorInput) input).getAdapter(IFile.class);
									if (file != null) {
										localPath = "file:/" + file.getLocation().toString();
									}
								}

								if (localPath != null) {
									remotePath = ChangeModelUtil.getRemoteModelUri(localPath);
									TransactionalEditingDomain transactionalEditingDomain = (TransactionalEditingDomain) domain;
									if (remotePath != null) {
										modelbusChangeModelResourceSetListener.commitChanges(transactionalEditingDomain, remotePath);
									}
								}
							}
						}
					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	@Override
	public void preExecute(String commandId, ExecutionEvent event) {
		// TODO Auto-generated method stub

	}

}
