package org.modelbus.team.eclipse.core;

import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.resource.impl.ExtensibleURIConverterImpl;
import org.eclipse.team.core.RepositoryProvider;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;

public class ModelBusUriConverter extends ExtensibleURIConverterImpl {

	private static IWorkspaceRoot	workspaceRoot	= EcorePlugin.getWorkspaceRoot();

	public ModelBusUriConverter() {
		super();
		fillURIMap();
	}

	private void fillURIMap() {
		Map<URI, URI> uriMap = this.getURIMap();
		if (workspaceRoot != null) {
			IProject[] projects = workspaceRoot.getProjects();
			for (IProject iProject : projects) {
				if (RepositoryProvider.isShared(iProject)) {
					RepositoryProvider repositoryProvider = RepositoryProvider.getProvider(iProject, ModelBusRepositoryPlugin.PROVIDER_ID);
					if (repositoryProvider != null) {
						ModelBusRepositoryProvider modelBusRepositoryProvider = (ModelBusRepositoryProvider) repositoryProvider;
						URI repositoryProjectPath = URI.createURI(modelBusRepositoryProvider.getRepositoryPath(iProject));
						if (!uriMap.containsKey(repositoryProjectPath)) {
							URI projectPath = URI.createURI("platform:/resource/" + iProject.getName() + "/");
							uriMap.put(repositoryProjectPath, projectPath);
						}

					}
				}
			}
		}
	}

}
