/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.modelbusstorage;

import org.modelbus.team.eclipse.core.connector.ModelBusRevision;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.core.resource.IRepositoryRoot;

/**
 * Implementation of IRepositoryRoot
 * 
 * @author Alexander Gurov
 */
public class ModelBusRepositoryRoot extends ModelBusRepositoryRootBase {
	private static final long	serialVersionUID	= 8314649604979930219L;

	public ModelBusRepositoryRoot() {
		// do not ask root URL if not required !
		super(null, ModelBusRevision.HEAD);
	}

	public String getUrl() {
		// return this.location.getRepositoryRootUrl();
		return "http://";
	}

	public IRepositoryResource getParent() {
		return null;
	}

	public IRepositoryResource getRoot() {
		return this;
	}

	public int getKind() {
		return IRepositoryRoot.KIND_ROOT;
	}

	public boolean equals(Object obj) {
		if (obj == null || !(obj instanceof IRepositoryRoot)) {
			return false;
		}
		// do not ask for root URL if not required !
		// if (this.getRepositoryLocation() == ((IRepositoryRoot)obj).getRepositoryLocation()) {
		if (this.getUrl() == ((IRepositoryRoot) obj).getUrl()) {
			System.out.println("TODOMWA20");
			return true;
		}
		// }
		return super.equals(obj);
	}

}
