/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.operation;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IResourceRuleFactory;
import org.eclipse.core.resources.team.ResourceRuleFactory;
import org.eclipse.core.runtime.jobs.ISchedulingRule;

/**
 * Resource scheduling rule factory implementation
 * 
 * @author Alexander Gurov
 */
public class ModelBusResourceRuleFactory extends ResourceRuleFactory {
	public static final IResourceRuleFactory	INSTANCE	= new ModelBusResourceRuleFactory();

	protected ModelBusResourceRuleFactory() {
		super();
	}

	public ISchedulingRule moveRule(IResource source, IResource destination) {
		return destination.getProject();
	}

}
