/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.operation.remote;

import org.eclipse.core.runtime.IProgressMonitor;
import org.modelbus.team.eclipse.core.connector.IModelBusConnector;
import org.modelbus.team.eclipse.core.connector.ModelBusEntryRevisionReference;
import org.modelbus.team.eclipse.core.operation.ModelBusProgressMonitor;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;

/**
 * Copy remote resources
 * 
 * @author Alexander Gurov
 */
public class CopyResourcesOperation extends AbstractCopyMoveResourcesOperation {
	public CopyResourcesOperation(IRepositoryResource destinationResource, IRepositoryResource[] selectedResources, String message, String name) {
		super("Operation.CopyRemote", destinationResource, selectedResources, message, name);
	}

	protected String[] getRevisionPaths(String srcUrl, String dstUrl) {
		return new String[] { dstUrl };
	}

	protected void runCopyMove(IModelBusConnector proxy, ModelBusEntryRevisionReference[] source, String destinationUrl, IProgressMonitor monitor)
			throws Exception {
		// this.writeToConsole(IConsoleStream.LEVEL_CMD, "modelbus copy \"" + ModelBusUtility.decodeURL(sourceUrl) + "\" \"" +
		// ModelBusUtility.decodeURL(destinationUrl) + "\" -r " + current.getSelectedRevision() + " -m \"" + this.message + "\"" +
		// FileUtility.getUsernameParam(location.getUsername()) + "\n");
		long options = IModelBusConnector.CommandMasks.COPY_SERVER;
		// if (CoreExtensionsManager.instance().getModelBusConnectorFactory().getModelBusAPIVersion() <
		// IModelBusConnectorFactory.APICompatibility.ModelBusAPI_1_5_x) {
		// options &= ~IModelBusConnector.Options.INTERPRET_AS_CHILD /*do not use ModelBus 1.5 options*/;
		// } CHECKMWA
		proxy.copy(source, destinationUrl, this.message, options, null, new ModelBusProgressMonitor(this, monitor, null));
	}

}
