package org.modelbus.team.eclipse.core.operation.remote;

import org.eclipse.core.runtime.IProgressMonitor;
import org.modelbus.team.eclipse.core.connector.IModelBusConnector;
import org.modelbus.team.eclipse.core.connector.ModelBusConnector;
import org.modelbus.team.eclipse.core.operation.IUnprotectedOperation;
import org.modelbus.team.eclipse.core.operation.ModelBusProgressMonitor;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;

public class UncontrolOperation extends AbstractRepositoryOperation {

	private String	resourceUri;
	private String	message;

	public UncontrolOperation(String resourceUri, String message, IRepositoryResource[] resources) {
		super("Operation.Uncontrol", resources);
		// TODO Auto-generated constructor stub
		this.resourceUri = resourceUri;
		this.message = message;
	}

	@Override
	protected void runImpl(IProgressMonitor monitor) throws Exception {
		// TODO Auto-generated method stub
		final IModelBusConnector proxy = ModelBusConnector.getModelBusConnector();
		this.protectStep(new IUnprotectedOperation() {
			public void run(IProgressMonitor monitor) throws Exception {
				if (!monitor.isCanceled()) {
					// try{
					// ProgressMonitorUtility.doTask(UncontrolOperation.this, monitor, DEFAULT_WEIGHT, IActionOperation.DEFAULT_WEIGHT);
					proxy.uncontrol(resourceUri, UncontrolOperation.this.message, new ModelBusProgressMonitor(UncontrolOperation.this, monitor, null));
					// }finally{
					// monitor.done();
					// }
				}

			}
		}, monitor, 1);
	}

}
