/**
 *  ModelBus is the means to interact with models in a distributed
 * consistent way.
 * 
 *  Copyright (C) 2008  Tom Ritter, Christian Hein, Michael Wagner
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.modelbus.team.eclipse.model.ui.mapping;

import org.eclipse.team.ui.mapping.SynchronizationActionProvider;
import org.eclipse.team.ui.synchronize.ISynchronizePageConfiguration;

/**
 * The action provider that is used for synchronizations. TODO comment
 * 
 * @author Michael Wagner
 * 
 */
public class ModelSyncActionProvider extends SynchronizationActionProvider {

	public ModelSyncActionProvider() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.team.ui.mapping.SynchronizationActionProvider#initialize()
	 */
	protected void initialize() {
		super.initialize();
		final ISynchronizePageConfiguration configuration = getSynchronizePageConfiguration();
		// We provide custom handlers that ensure that the MOD files get updated properly
		// when MOE files are merged.
		registerHandler(MERGE_ACTION_ID, new ModelMergeActionHandler(configuration, false));
		registerHandler(OVERWRITE_ACTION_ID, new ModelMergeActionHandler(configuration, true));
		// We can just use the default mark as merged handler
	}
}
