/**
 *  ModelBus is the means to interact with models in a distributed
 * consistent way.
 * 
 *  Copyright (C) 2008  Tom Ritter, Christian Hein, Michael Wagner
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.modelbus.team.eclipse.notification.views;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;

public abstract class AbstractInvertableTableSorter extends InvertableSorter {
	private final InvertableSorter	inverse	= new InvertableSorter() {

												public int compare(Viewer viewer, Object e1, Object e2) {
													return (-1) * AbstractInvertableTableSorter.this.compare(viewer, e1, e2);
												}

												InvertableSorter getInverseSorter() {
													return AbstractInvertableTableSorter.this;
												}

												public int getSortDirection() {
													return SWT.DOWN;
												}
											};

	InvertableSorter getInverseSorter() {
		return inverse;
	}

	public int getSortDirection() {
		return SWT.UP;
	}
}
