/**
 *  ModelBus is the means to interact with models in a distributed
 * consistent way.
 * 
 *  Copyright (C) 2008  Tom Ritter, Christian Hein, Michael Wagner
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.modelbus.team.eclipse.notification.views;

import org.eclipse.jface.viewers.Viewer;

public class TextSorter extends AbstractInvertableTableSorter {

	private int	column	= 0;

	public TextSorter(int column) {
		this.column = column;
	}

	@Override
	public int compare(final Viewer viewer, final Object e1, final Object e2) {

		if (e1 == null || e2 == null) {
			return 0;
		}
		if (e1 != null && e1 instanceof Object[] && (((Object[]) e1).length > column) && ((Object[]) e1)[column] instanceof Comparable
				&& e2 instanceof Object[] && (((Object[]) e2).length > column)) {
			return ((Comparable) ((Object[]) e1)[column]).compareTo(((Object[]) e2)[column]);
		}
		if (e2 != null && e2 instanceof Comparable) {
			return ((Comparable) e2).compareTo(e1);
		}

		if (e1 != null && e1 instanceof Comparable) {
			return ((Comparable) e1).compareTo(e2);
		}
		if (e2 != null && e2 instanceof Comparable) {
			return ((Comparable) e2).compareTo(e1);
		}
		return 0;
	}

}