package org.modelbus.team.eclipse.repository;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.internal.preferences.Base64;

public class ResourceUtil {

	public static String[] decodeStringToArray(String encodedString) {
		String[] valuesArray = new String[] {};
		if (encodedString != null && encodedString.length() > 0) {
			valuesArray = encodedString.split(";");
			for (int i = 0; i < valuesArray.length; i++) {
				valuesArray[i] = new String(Base64.decode(valuesArray[i].getBytes()));
			}
		}
		return valuesArray;
	}

	public static String getResource(ResourceBundle bundle, String key) {
		if (key == null) {
			return null;
		}
		if (bundle == null) {
			return key;
		}
		String retVal = getResourceImpl(bundle, key);
		if (retVal != null) {
			if (key.indexOf("Error") != -1) {
				String id = getResourceImpl(bundle, key + ".Id");
				if (id != null) {
					retVal = id + ": " + retVal;
				}
			}
			return retVal;
		}
		return key;
	}

	private static String getResourceImpl(ResourceBundle bundle, String key) {
		try {
			return bundle.getString(key);
		} catch (MissingResourceException ex) {
			return null;
		}
	}

	public static String flattenText(String text) {
		StringBuffer flat = new StringBuffer(text.length() + 20);
		boolean skipAdjacentLineSeparator = true;
		for (int i = 0; i < text.length(); i++) {
			char currentChar = text.charAt(i);
			if (currentChar == '\r' || currentChar == '\n') {
				if (!skipAdjacentLineSeparator)
					flat.append("/");
				skipAdjacentLineSeparator = true;
			} else {
				flat.append(currentChar);
				skipAdjacentLineSeparator = false;
			}
		}
		return flat.toString().replace('\t', ' ');
	}

}
