package org.modelbus.team.eclipse.repository.history;

import java.io.InputStream;

import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.URI;
import org.eclipse.team.core.history.IFileRevision;
import org.eclipse.team.core.history.provider.FileRevision;
import org.modelbus.core.lib.IRepositoryHelper;
import org.modelbus.core.lib.util.ModelBusCoreUtil.URIUtil;
import org.modelbus.dosgi.repository.descriptor.RepositoryDirEntry;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryHelper;
import org.modelbus.team.eclipse.repository.UserSessionHelper;

public class ModelBusRepositoryFileRevision extends FileRevision {

	RepositoryDirEntry	remoteFile;

	public ModelBusRepositoryFileRevision(RepositoryDirEntry file) {
		this.remoteFile = file;
	}

	public String getName() {
		return remoteFile.getName();
	}

	public long getTimestamp() {
		return remoteFile.getCreationDate().toGregorianCalendar().getTimeInMillis();
	}

	public IStorage getStorage(IProgressMonitor monitor) throws CoreException {
		return new IStorage() {

			public InputStream getContents() throws CoreException {

				try {
					// String repLocation = org.modelbus.preferences.ModelBusPreferencePlugin.getDefault().getPreferenceStore().getString(
					// org.modelbus.preferences.PreferenceConstants.REPOSITORY_LOCATION_STRING);
					// boolean checkDependencies = org.modelbus.preferences.dependencies.DependenciesPreferencePlugin
					// .getDefault()
					// .getPreferenceStore()
					// .getBoolean(org.modelbus.preferences.dependencies.preferences.PreferenceConstants.CHECK_DEPENDENCIES);
					// String[] modelExtensions = org.modelbus.preferences.dependencies.DependenciesPreferencePlugin
					// .getDefault().getExtensionPreference();
					//
					// RepositoryHelper repositoryHelper = new RepositoryHelper(repLocation,checkDependencies,modelExtensions);
					IRepositoryHelper repositoryHelper = ModelBusRepositoryHelper.getRepositoryHelper();
					InputStream stream = repositoryHelper.checkOutFile(UserSessionHelper.getSession(), URI.createURI(remoteFile.getUri()),
							remoteFile.getRevision());

					// RepositoryStub stub = new RepositoryStub(repLocation);
					// ServiceClient serviceClient = stub._getServiceClient();
					// // ServiceClient serviceClient = new ServiceClient ();
					// Options options = new Options();
					// options.setTo(new EndpointReference(repLocation));
					// options.setProperty(Constants.Configuration.ENABLE_MTOM,
					// Constants.VALUE_TRUE);
					// //
					// options.setProperty(Constants.Configuration.ENABLE_SWA,
					// // Constants.VALUE_TRUE);
					// options.setProperty(Constants.Configuration.CACHE_ATTACHMENTS,
					// Constants.VALUE_TRUE);
					// options.setProperty(Constants.Configuration.ATTACHMENT_TEMP_DIR,
					// "/tmp");
					// options.setProperty(Constants.Configuration.FILE_SIZE_THRESHOLD,
					// "4096");
					// options.setTransportInfo(Constants.TRANSPORT_HTTP,
					// Constants.TRANSPORT_HTTP, false);
					// options.setSoapVersionURI(SOAP12Constants.SOAP_ENVELOPE_NAMESPACE_URI);
					// options.setProperty(org.apache.axiom.om.OMConstants.IS_BINARY,
					// Constants.VALUE_TRUE);
					// // serviceClient.get
					// serviceClient.setOptions(options);
					// CheckPath checkPath = new CheckPath();
					// checkPath.setPath(remoteFile.getUrl().toString());
					// checkPath.setRevision(-1);
					// CheckPathResponse pathResponse =
					// stub.checkPath(checkPath);
					// if
					// (pathResponse.getNodeKind().equals(RepositoryNodeKind.FILE))
					// {
					// CheckOutFile checkoutModel = new CheckOutFile();
					//
					// checkoutModel.setFileUri(new
					// URI(remoteFile.getUrl().toString()));
					// CheckOutFileResponse response =
					// stub.checkOutFile(checkoutModel);
					// if (response.getFileContent() != null) {
					// InputStream stream =
					// response.getFileContent().getDataSource().getInputStream();
					//
					// return stream;
					// }
					// }
					return stream;
				} catch (Exception e) {
					e.printStackTrace();
					throw new RuntimeException(e);
				}

			}

			public IPath getFullPath() {
				// throw new RuntimeException("NYI");
				// return new Path(remoteFile.getAbsolutePath());
				String uri = remoteFile.getUri();
				String path = null;
				if (URIUtil.isHTTPURI(uri)) {
					path = uri.substring("http://".length());
				} else {
					path = uri;
				}

				return new Path(null, path);
			}

			public String getName() {
				return remoteFile.getName();
			}

			public boolean isReadOnly() {
				return true;
			}

			public Object getAdapter(Class adapter) {
				return null;
			}

		};
	}

	public boolean isPropertyMissing() {
		return false;
	}

	public IFileRevision withAllProperties(IProgressMonitor monitor) throws CoreException {
		return null;
	}

	public String getContentIdentifier() {
		return "[File System Revision]"; //$NON-NLS-1$
	}

}
