package org.modelbus.team.eclipse.repository.subscriber;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import org.eclipse.team.core.TeamException;

public class ModelBusSyncByteConverter {

	// protected static final byte SEPARATOR_BYTE = (byte)255;

	/**
	 * Change the slot to the given bytes
	 * 
	 * @param syncBytes
	 *            the sync bytes
	 * @param slot
	 *            the slot location
	 * @param newBytes
	 *            the bytes to be put in the slot
	 * @return the new sync bytes
	 * @throws TeamException
	 */
	// public static byte[] setSlot(byte[] syncBytes, int slot, byte[] newBytes)
	// throws TeamException {
	// ArrayList<byte[]> collect = new ArrayList<byte[]>();
	// int currentPos = 0;
	// int newLength = 0;
	// for (int j = 0; currentPos < syncBytes.length; j++) {
	// int length = byteArrayToInt(syncBytes, currentPos);
	// currentPos = currentPos + 4;
	// byte[] array = new byte[length];
	// System.arraycopy(syncBytes, currentPos, array, 0, length);
	// collect.add(array);
	// currentPos = currentPos + length;
	// newLength = newLength + 4;
	// if (j != slot) {
	// newLength = newLength +length;
	// }
	// }
	// newLength = newLength +newBytes.length;
	// collect.set(slot, newBytes);
	// byte[] result = new byte[newLength];
	// int pos = 0;
	// for (int i = 0; i < collect.size(); i++) {
	// intToByteArray(collect.get(i).length, pos, result);
	// pos = pos +4;
	// System.arraycopy(collect.get(i), 0, result, pos, collect.get(i).length);
	// pos = pos +collect.get(i).length;
	// }
	// return result;
	// }

	public static byte[] setSlot(byte[] syncBytes, int slot, byte[] newBytes) throws TeamException {
		ArrayList<byte[]> collect = new ArrayList<byte[]>();
		int currentPos = 0;
		int newLength = 0;
		for (int j = 0; currentPos < syncBytes.length; j++) {
			int length = byteArrayToInt(syncBytes, currentPos);
			currentPos = currentPos + 4;
			byte[] array = new byte[length];
			System.arraycopy(syncBytes, currentPos, array, 0, length);
			collect.add(array);
			currentPos = currentPos + length;
			newLength = newLength + 4;
			if (j != slot) {
				newLength = newLength + length;
			}
		}
		newLength = newLength + newBytes.length;
		collect.set(slot, newBytes);
		byte[] result = new byte[newLength];
		int pos = 0;
		for (int i = 0; i < collect.size(); i++) {
			intToByteArray(collect.get(i).length, pos, result);
			pos = pos + 4;
			System.arraycopy(collect.get(i), 0, result, pos, collect.get(i).length);
			pos = pos + collect.get(i).length;
		}
		return result;
	}

	/**
	 * Method startOfSlot returns the index of the slash that occurs before the given slot index. The provided index should be >= 1 which assumes that
	 * slot zero occurs before the first slash.
	 * 
	 * @param syncBytes
	 * @param i
	 * @return int
	 */
	// private static int startOfSlot(byte[] syncBytes, int slot) {
	// int currentPos = 0;
	// for (int j = 0; j < slot; j++) {
	// currentPos = currentPos+byteArrayToInt(syncBytes, currentPos)+4;
	// }
	// return currentPos+4;
	// }

	private static int startOfSlot(byte[] syncBytes, int slot) {
		int currentPos = 0;
		for (int j = 0; j < slot; j++) {
			currentPos = currentPos + byteArrayToInt(syncBytes, currentPos) + 4;
		}
		return currentPos + 4;
	}

	private static final byte[] intToByteArray(int value, int pos, byte[] src) {
		src[pos] = (byte) (value >>> 24);
		src[pos + 1] = (byte) (value >>> 16);
		src[pos + 2] = (byte) (value >>> 8);
		src[pos + 3] = (byte) value;
		return src;
	}

	private static final int byteArrayToInt(byte[] b, int pos) {
		return (b[pos] << 24) + ((b[pos + 1] & 0xFF) << 16) + ((b[pos + 2] & 0xFF) << 8) + (b[pos + 3] & 0xFF);
	}

	/**
	 * Get the bytes in the given slot.
	 * 
	 * @param bytes
	 *            the sync bytes
	 * @param index
	 *            the slot location
	 * @param includeRest
	 *            whether to include the rest
	 * @return the bytes in the given slot
	 */
	// public static byte[] getSlot(byte[] bytes, int index, boolean includeRest) {
	// int currentPos = 0;
	// for (int j = 0; j < index; j++) {
	// currentPos = currentPos+byteArrayToInt(bytes, currentPos)+4;
	// }
	// int length = byteArrayToInt(bytes, currentPos);
	// byte[] result = new byte[length];
	// System.arraycopy(bytes, currentPos+4, result, 0, length);
	// return result;
	// }

	public static byte[] getSlot(byte[] bytes, int index, boolean includeRest) {
		int currentPos = 0;
		for (int j = 0; j < index; j++) {
			currentPos = currentPos + byteArrayToInt(bytes, currentPos) + 4;
		}
		int length = byteArrayToInt(bytes, currentPos);
		byte[] result = new byte[length];
		System.arraycopy(bytes, currentPos + 4, result, 0, length);
		return result;
	}

	// public static byte[] toBytes(String timeStamp, byte[] base, byte[] remote) {
	// byte[][] byteArrays = new byte[3][];
	// int length = 0;
	// try {
	// byteArrays[0] = timeStamp.getBytes("UTF8");
	// } catch (UnsupportedEncodingException e) {
	// e.printStackTrace();
	// }
	// byteArrays[1] = base;
	// byteArrays[2] = remote;
	// length = length + byteArrays[0].length;
	// length = length + byteArrays[1].length;
	// length = length + byteArrays[2].length;
	// length = length + 4* 3;
	// byte[] result = new byte[length];
	// int pos = 0;
	// for (int i = 0; i < 3; i++) {
	// intToByteArray(byteArrays[i].length, pos, result);
	// pos = pos +4;
	// System.arraycopy(byteArrays[i], 0, result, pos, byteArrays[i].length);
	// pos = pos +byteArrays[i].length;
	// }
	// return result;
	// }

	// plus revision
	public static byte[] toBytes(String revision, String timeStamp, byte[] base, byte[] remote) {
		byte[][] byteArrays = new byte[4][];
		int length = 0;
		try {
			byteArrays[0] = revision.getBytes("UTF8");
			byteArrays[1] = timeStamp.getBytes("UTF8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		byteArrays[2] = base;
		byteArrays[3] = remote;
		length = length + byteArrays[0].length;
		length = length + byteArrays[1].length;
		length = length + byteArrays[2].length;
		length = length + byteArrays[3].length;
		length = length + 4 * 4;
		byte[] result = new byte[length];
		int pos = 0;
		for (int i = 0; i < 4; i++) {
			intToByteArray(byteArrays[i].length, pos, result);
			pos = pos + 4;
			System.arraycopy(byteArrays[i], 0, result, pos, byteArrays[i].length);
			pos = pos + byteArrays[i].length;
		}
		return result;
	}

	public static void main(String[] args) throws UnsupportedEncodingException, TeamException {
		// byte[] container = toBytes(new String[] { "test1", "test2", "" });
		// if (!new String (getSlot(container, 1, true), "UTF8").equals("test2")) {
		// throw new RuntimeException("test1");
		// }
		// if (!new String (getSlot(container, 2, true), "UTF8").equals("")) {
		// throw new RuntimeException("test2");
		// }
		// container = setSlot(container, 1, "test3".getBytes("UTF8"));
		// if (!new String (getSlot(container, 1, true), "UTF8").equals("test3")) {
		// throw new RuntimeException("test3");
		// }
		// System.out.print("Done!");
	}

}
