package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.LabelProviderChangedEvent;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.team.core.variants.ISynchronizerChangeListener;
import org.eclipse.ui.progress.UIJob;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;

public abstract class AbstractModelBusDecoratorWrapper extends LabelProvider implements ILightweightLabelDecorator, ISynchronizerChangeListener {

	private AbstractModelBusDecoratorWrapper	abstractModelBusDecoratorWrapper;

	public AbstractModelBusDecoratorWrapper() {
		abstractModelBusDecoratorWrapper = this;
	}

	public void syncStateChanged(IResource[] resources) {
		// TODO Auto-generated method stub
		abstractModelBusDecoratorWrapper.refreshDecorator();

	}

	public boolean isModelBusShared(IResource resource) {

		if (resource == null) {
			return false;
		}
		IProject project = resource.getProject();
		if (project == null) {
			return false;
		}
		RepositoryProvider provider = RepositoryProvider.getProvider(project, ModelBusRepositoryPlugin.PROVIDER_ID);
		if (provider instanceof ModelBusRepositoryProvider) {
			return true;
		}
		return false;

	}

	private void refreshDecorator() {
		UIJob go = new UIJob("ModelBusDecorator") {

			@Override
			public IStatus runInUIThread(IProgressMonitor monitor) {
				// TODO Auto-generated method stub
				try {
					abstractModelBusDecoratorWrapper.fireLabelProviderChanged(new LabelProviderChangedEvent(abstractModelBusDecoratorWrapper));
				} catch (Exception e) {
					e.printStackTrace();
				}

				return Status.OK_STATUS;
			}
		};
		go.setSystem(true);
		go.setUser(false);
		go.schedule();
	}
}
