package org.modelbus.team.eclipse.repository.ui;

import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.LabelProviderChangedEvent;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.UserSessionHelper;

public class LockDecorator extends LabelProvider implements ILightweightLabelDecorator {

	private static LockDecorator	lockDecorator	= null;
	private final String			ICON_PATH		= "icons/";

	public LockDecorator() {
		lockDecorator = this;
	}

	public static void refreshDecoration() {
		lockDecorator.fireLabelProviderChanged(new LabelProviderChangedEvent(lockDecorator));
	}

	@Override
	public void decorate(Object element, IDecoration decoration) {
		// TODO Auto-generated method stub
		// if(element instanceof EObject || element instanceof IFile){
		// EObject object = (EObject)element;
		try {
			String user = LockHelper.getLockHelper().objectLockedBy(element);
			if (user == null) {
				return;
			}
			if (user.equals(UserSessionHelper.getPropertyUserName())) {
				decoration.addOverlay(createImageDescriptor("lock_green.gif"));
				decoration.addSuffix("[locked]");
			} else {
				decoration.addOverlay(createImageDescriptor("lock_red.gif"));
				decoration.addSuffix("[locked by " + user + " ]");
			}
		} catch (Exception e) {
			return;
		}
		// }

	}

	/**
	 * Creates an image descriptor.
	 */
	private ImageDescriptor createImageDescriptor(String id) {
		URL url = FileLocator.find(ModelBusRepositoryPlugin.getPlugin().getBundle(), new Path(ICON_PATH + id), null);
		return ImageDescriptor.createFromURL(url);
	}

}
