package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.mapping.ResourceTraversal;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.team.core.subscribers.SubscriberScopeManager;
import org.eclipse.ui.IWorkbenchPart;
import org.modelbus.dosgi.repository.descriptor.InvalidValueException;
import org.modelbus.dosgi.repository.descriptor.LockedException;
import org.modelbus.dosgi.repository.descriptor.NonExistingResourceException;
import org.modelbus.dosgi.repository.descriptor.RepositoryAuthentificationException;
import org.modelbus.dosgi.repository.descriptor.RepositoryRuntimeException;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;
import org.modelbus.team.eclipse.repository.Policy;

public class LockOperation extends ModelBusRepositoryOperation {

	protected LockOperation(IWorkbenchPart part, SubscriberScopeManager manager) {
		super(part, manager);
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void execute(ModelBusRepositoryProvider provider, ResourceTraversal[] traversals, IProgressMonitor monitor) throws CoreException,
			InvalidValueException, NonExistingResourceException {
		for (int i = 0; i < traversals.length; i++) {
			ResourceTraversal resourceTraversal = traversals[i];
			IResource[] resources = resourceTraversal.getResources();
			for (int j = 0; j < resources.length; j++) {
				IResource resource = resources[j];
				if (resource != null && resource instanceof IFile) {
					try {
						provider.getOperations().lock((IFile) resource, monitor);
					} catch (RepositoryAuthentificationException e) {
						throw new RuntimeException(e);
					} catch (RepositoryRuntimeException e) {
						throw new RuntimeException(e);
					} catch (LockedException e) {
						throw new RuntimeException(e);
					}
				}
			}
		}

	}

	@Override
	protected String getTaskName() {
		return Policy.bind("LockAction.working"); //$NON-NLS-1$
	}

}
