package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.viewers.IDecoration;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusRepositorySubscriber;

public class ModelBusResourceDecoratorWrapper extends AbstractModelBusDecoratorWrapper {

	private ModelBusResourceDecorator	modelBusResourceDecorator;

	public ModelBusResourceDecoratorWrapper() {
		super();
		ModelBusRepositorySubscriber.getInstance().getSynchronizer().addListener(this);
	}

	@Override
	public void decorate(Object element, IDecoration decoration) {
		// TODO Auto-generated method stub
		if ((element instanceof IFile || element instanceof IFolder) && isModelBusShared((IResource) element)) {
			this.getModelBusResourceDecorator().decorate(element, decoration);
		}

	}

	private synchronized ModelBusResourceDecorator getModelBusResourceDecorator() {

		if (this.modelBusResourceDecorator == null) {
			this.modelBusResourceDecorator = new ModelBusResourceDecorator();
		}
		return this.modelBusResourceDecorator;
	}

}
