package org.modelbus.team.eclipse.repository.ui;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.modelbus.team.eclipse.repository.Policy;
import org.modelbus.team.eclipse.repository.UserSessionHelper;

public class UnLockAction extends ModelBusRepositoryAction {

	@Override
	protected void execute(IAction arg0) throws InvocationTargetException, InterruptedException {
		try {
			UnLockOperation operation = new UnLockOperation(getTargetPart(), ModelBusRepositoryOperation.createScopeManager(
					Policy.bind("UnLockAction.working"), getSelectedMappings())); //$NON-NLS-1$
			// operation.setOverwriteIncoming(isOverrideIncoming());
			operation.run();
		} catch (InvocationTargetException e) {
			handle(e, null, Policy.bind("UnLockAction.problemMessage")); //$NON-NLS-1$
		} catch (InterruptedException e) {
			// Ignore
		}

	}

	@Override
	public boolean isEnabled() {
		IResource[] resources = getSelectedResources();
		if (resources == null) {
			return false;
		}
		if (resources.length != 1) {
			return false;
		}
		if (resources[0] == null) {
			return false;
		}
		IResource resource = resources[0];

		try {
			String user = LockHelper.getLockHelper().objectLockedBy(resource);
			if (user != null && user.equals(UserSessionHelper.getPropertyUserName()) && LockHelper.getLockHelper().isDirectLocked(resource)) {
				return true;
			}
		} catch (Exception e) {
			return false;
		}
		return false;
	}

}
