/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.action.local;

import org.eclipse.compare.CompareConfiguration;
import org.eclipse.compare.CompareUI;
import org.eclipse.compare.internal.CompareEditor;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.eclipse.team.core.RepositoryProvider;
import org.modelbus.core.lib.IRepositoryHelper;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;
import org.modelbus.team.eclipse.ui.action.AbstractWorkingCopyAction;
import org.modelbus.team.eclipse.ui.compare.ModelBusCompareEditorInput;

/**
 * Compare menu "compare with latest revision" action implementation
 * 
 * @author Alexander Gurov
 */
public class CompareWithLatestRevisionAction extends AbstractWorkingCopyAction {

	public CompareWithLatestRevisionAction() {
		super();
	}

	public void runImpl(IAction action) {
		IResource resource = this.getSelectedResources()[0];

		RepositoryProvider provider = RepositoryProvider.getProvider(resource.getProject(), ModelBusRepositoryPlugin.PROVIDER_ID);

		CompareConfiguration configuration = new CompareConfiguration();
		configuration.setProperty(CompareEditor.CONFIRM_SAVE_PROPERTY, Boolean.TRUE);
		ModelBusCompareEditorInput compare = new ModelBusCompareEditorInput(configuration, provider, resource,/* ModelBusRevision.HEAD */IRepositoryHelper.REVISION_HEAD);
		CompareUI.openCompareEditor(compare);

	}

	public boolean isEnabled() {
		boolean isCompareFoldersAllowed = true; // CHECKMWA CoreExtensionsManager.instance().getModelBusConnectorFactory().getModelBusAPIVersion() ==
												// IModelBusConnectorFactory.APICompatibility.ModelBusAPI_1_5_x;
		if (this.getSelectedResources().length != 1) {
			return false;
		}
		RepositoryProvider provider = RepositoryProvider.getProvider(this.getSelectedResources()[0].getProject(),
				ModelBusRepositoryPlugin.PROVIDER_ID);
		if (provider instanceof ModelBusRepositoryProvider && (isCompareFoldersAllowed || this.getSelectedResources()[0].getType() == IResource.FILE)) {
			return true;
		}
		return false;
		// return
		// this.getSelectedResources().length == 1 && RepositoryProvider.isShared(getSelectedResources()[0].getProject()) &&
		// (isCompareFoldersAllowed || this.getSelectedResources()[0].getType() == IResource.FILE); //&&
		// this.checkForResourcesPresence(CompareWithWorkingCopyAction.COMPARE_FILTER);
	}

	protected boolean needsToSaveDirtyEditors() {
		return true;
	}

}
