/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.action.remote;

import org.eclipse.jface.action.IAction;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.ui.dialog.DefaultDialog;
import org.modelbus.team.eclipse.ui.panel.remote.CompareBranchTagPanel;

/**
 * Compare with branch /tag action implementation
 * 
 * @author Alexander Gurov
 */
public class CompareWithBranchTagAction extends CompareAction {
	protected int	type;

	public CompareWithBranchTagAction(int type) {
		super();
		this.type = type;
	}

	public boolean isEnabled() {
		// MES: Always disabled
		// if (super.isEnabled()) {
		// IRepositoryResource first = this.getSelectedRepositoryResources()[0];
		// return
		// // CHECKMWA first.getRepositoryLocation().isStructureEnabled() &&
		// ModelBusTeamPreferences.getRepositoryBoolean(ModelBusTeamUIPlugin.instance().getPreferenceStore(),
		// ModelBusTeamPreferences.BRANCH_TAG_CONSIDER_STRUCTURE_NAME);
		// }
		return false;
	}

	public void runImpl(IAction action) {
		IRepositoryResource first = this.getSelectedRepositoryResources()[0];
		CompareBranchTagPanel panel = new CompareBranchTagPanel(first, this.type);
		DefaultDialog dlg = new DefaultDialog(this.getShell(), panel);
		if (dlg.open() == 0) {
			this.doCompare(first, panel.getSelectedResoure());
		}
	}

}
