/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.action.remote;

import org.eclipse.jface.action.IAction;
import org.modelbus.team.eclipse.core.connector.ModelBusRevision.Kind;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.core.resource.IRepositoryRoot;
import org.modelbus.team.eclipse.ui.RemoteResourceTransferrable;
import org.modelbus.team.eclipse.ui.action.AbstractRepositoryTeamAction;
import org.modelbus.team.eclipse.ui.operation.PrepareRemoteResourcesTransferrableOperation;

/**
 * Cut remote resource into clipboard action implementation
 * 
 * @author Alexander Gurov
 */
public class CutAction extends AbstractRepositoryTeamAction {

	public CutAction() {
		super();
	}

	public void runImpl(IAction action) {
		this.runBusy(new PrepareRemoteResourcesTransferrableOperation(this.getSelectedRepositoryResources(), RemoteResourceTransferrable.OP_CUT, this
				.getShell().getDisplay()));
	}

	public boolean isEnabled() {
		IRepositoryResource[] resources = this.getSelectedRepositoryResources();
		if (resources.length == 0) {
			return false;
		}
		// disable transfer between different repositories
		for (int i = 0; i < resources.length; i++) {
			if (resources[i].getSelectedRevision().getKind() != Kind.HEAD
					|| resources[i] instanceof IRepositoryRoot
					&& (((IRepositoryRoot) resources[i]).getKind() == IRepositoryRoot.KIND_ROOT || ((IRepositoryRoot) resources[i]).getKind() == IRepositoryRoot.KIND_LOCATION_ROOT)) {
				return false;
			}
		}
		return true;
	}

}
