package org.modelbus.team.eclipse.ui.action.remote;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.jobs.ISchedulingRule;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.modelbus.team.eclipse.core.operation.AbstractActionOperation;
import org.modelbus.team.eclipse.core.operation.CompositeOperation;
import org.modelbus.team.eclipse.core.operation.remote.UncontrolOperation;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.core.utility.ModelBusUtility;
import org.modelbus.team.eclipse.ui.action.AbstractRepositoryTeamAction;
import org.modelbus.team.eclipse.ui.operation.RefreshRemoteResourcesOperation;
import org.modelbus.team.eclipse.ui.repository.RepositoriesView;

public class UncontrolAction extends AbstractRepositoryTeamAction {

	private EObject	selectedElement;

	public UncontrolAction() {
		// TODO Auto-generated constructor stub
		super();
	}

	@Override
	public boolean isEnabled() {
		// TODO Auto-generated method stub
		IStructuredSelection selection = this.getSelection();
		Object object = ((IStructuredSelection) selection).getFirstElement();
		if (object instanceof EObject) {
			EObject eObject = (EObject) object;
			if (eObject.eResource().getURI().scheme().equals("http")) {
				selectedElement = eObject;
				EObject container = eObject.eContainer();
				// Resource resource = eObject.eResource();
				// return resource != null && container != null && resource != container.eResource();
				return true;
			}

		}
		return false;
	}

	@Override
	public void runImpl(IAction action) {
		// TODO: implement uncontrol log message
		final String logMessage = "TODO: implement uncontrol log message";
		Resource resource = selectedElement.eResource();
		URI resourceUri = resource.getURI();
		IRepositoryResource selectedResource = ModelBusUtility.asRepositoryResource(resourceUri.toString(), false);
		IRepositoryResource[] resources = new IRepositoryResource[] { selectedResource };
		IRepositoryResource[] commonParents = ModelBusUtility.getCommonParents(resources);
		UncontrolOperation mainOp = new UncontrolOperation(resourceUri.toString(), logMessage, resources);
		CompositeOperation op = new CompositeOperation(mainOp.getId());
		op.add(mainOp);
		op.add(new RefreshRemoteResourcesOperation(commonParents));
		op.add(new AbstractActionOperation("") {
			protected void runImpl(IProgressMonitor monitor) throws Exception {
				UncontrolAction.this.getShell().getDisplay().syncExec(new Runnable() {
					public void run() {
						RepositoriesView view = RepositoriesView.instance();
						if (view == null) {
							return;
						}

						view.getRepositoryTree().fireEmptySelectionEvent();
					}
				});
			}

			public ISchedulingRule getSchedulingRule() {
				return null;
			}
		});
		this.runScheduled(op);

	}

}
