/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexei Goncharov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.compare;

import org.eclipse.compare.CompareConfiguration;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.viewers.TreeSelection;
import org.modelbus.team.eclipse.core.connector.ModelBusEntryRevisionReference;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;

/**
 * Compare input for comparison remote resources' ModelBus properties.
 * 
 * @author Alexei Goncharov
 */
public class TwoWayPropertyCompareInput extends PropertyCompareInput {

	public TwoWayPropertyCompareInput(CompareConfiguration configuration, ModelBusEntryRevisionReference left, ModelBusEntryRevisionReference right) {
		super(configuration, left, right, null);
	}

	protected void fillMenu(IMenuManager manager, TreeSelection selection) {
		// is menu needed???
	}

	public String getTitle() {
		String nameLeft = this.left.path.substring(this.left.path.lastIndexOf("/") + 1);
		String nameRight = this.right.path.substring(this.right.path.lastIndexOf("/") + 1);
		if (nameLeft.equals(nameRight)) {
			return ModelBusTeamUIPlugin.instance().getResource("PropertyCompareInput.Title2",
					new String[] { nameLeft + " [" + this.getRevisionPart(this.left), this.getRevisionPart(this.right) + "] " });
		}
		return ModelBusTeamUIPlugin.instance().getResource("PropertyCompareInput.Title2",
				new String[] { nameLeft + " [" + this.getRevisionPart(this.left) + "]", nameRight + " [" + this.getRevisionPart(this.right) + "] " });

	}

	protected String getRevisionPart(ModelBusEntryRevisionReference reference) {
		return ModelBusTeamUIPlugin.instance().getResource("ResourceCompareInput.RevisionSign", new String[] { String.valueOf(reference.revision) });
	}

}
