/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.crashrecovery;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.IPath;
import org.modelbus.team.eclipse.core.extension.crashrecovery.ErrorDescription;
import org.modelbus.team.eclipse.core.extension.crashrecovery.IResolutionHelper;
import org.modelbus.team.eclipse.core.utility.ModelBusUtility;

/**
 * Handle invalid meta-information problem here
 * 
 * @author Alexander Gurov
 */
public class InvalidMetaHelper implements IResolutionHelper {

	public boolean acquireResolution(ErrorDescription description) {
		if (description.code == ErrorDescription.CANNOT_READ_PROJECT_METAINFORMATION) {
			final IProject project = (IProject) description.context;
			IPath location = project.getLocation();
			if (location == null || !location.append(ModelBusUtility.getModelBusFolderName()).toFile().exists()) {
				return false;
			}
			// IModelBusConnectorFactory current = CoreExtensionsManager.instance().getModelBusConnectorFactory();
			String path = location.toString();
			// // check if already handled for any other project
			// if (this.isValid(current, path)) {
			// return true;
			// }
			// final ArrayList<IModelBusConnectorFactory> valid = new ArrayList<IModelBusConnectorFactory>();
			// for (IModelBusConnectorFactory factory : CoreExtensionsManager.instance().getAccessibleClients()) {
			// if (this.isValid(factory, path)) {
			// valid.add(factory);
			// }
			// }
			// if (valid.size() == 0) {
			// return false;
			// }

			final boolean[] solved = new boolean[] { false };
			// UIMonitorUtility.parallelSyncExec(new Runnable() {
			// public void run() {
			// DefaultDialog dialog = new DefaultDialog(UIMonitorUtility.getShell(), new ValidConnectorsSelectionPanel(project, valid));
			// solved[0] = dialog.open() == 0;
			// }
			// }); CHECKMWA
			// // if user pressed "Ok" the project can be recovered
			return solved[0];
		}
		return false;
	}

	// protected boolean isValid(IModelBusConnectorFactory factory, String path) {
	// // try {
	// // IModelBusConnector proxy = factory.newInstance();
	// // try {
	// // ModelBusChangeStatus []st = ModelBusUtility.status(proxy, path, Depth.IMMEDIATES, IModelBusConnector.Options.INCLUDE_UNCHANGED, new
	// ModelBusNullProgressMonitor());
	// // return st != null && st.length > 0;
	// // }
	// // finally {
	// // proxy.dispose();
	// // }
	// // }
	// // catch (Throwable ex) {
	// // any exception including instantiation problems...
	// return false;
	// // }
	// }

}
