/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.extension.impl;

import org.eclipse.core.resources.IProject;
import org.modelbus.team.eclipse.core.operation.local.management.ShareProjectOperation;
import org.modelbus.team.eclipse.ui.extension.factory.IShareProjectFactory;
import org.modelbus.team.eclipse.ui.wizard.shareproject.SelectProjectNamePage;

/**
 * Default implementation
 * 
 * @author Alexander Gurov
 */
public class DefaultShareProjectFactory implements IShareProjectFactory {

	public DefaultShareProjectFactory() {

	}

	public SelectProjectNamePage getProjectLayoutPage() {
		return new SelectProjectNamePage();
	}

	public ShareProjectOperation getShareProjectOperation(IProject[] projects, SelectProjectNamePage page, String commitComment) {
		return new ShareProjectOperation(projects, page.getSelectedNames(), page.getRootProjectName(), page.getLayoutType(),
				page.isManagementFoldersEnabled(), commitComment);
	}

	public boolean disallowFinishOnAddRepositoryLocation(IProject[] projects) {
		return false;
	}

	public boolean disallowFinishOnCommitComment(IProject[] projects) {
		return false;
	}

	public boolean disallowFinishOnAlreadyConnected(IProject[] projects) {
		return false;
	}

	public boolean disallowFinishOnSelectRepositoryLocation(IProject[] projects) {
		return false;
	}

}
