/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.history;

import org.eclipse.core.resources.IResource;
import org.modelbus.team.eclipse.core.connector.ModelBusLogEntry;
import org.modelbus.team.eclipse.core.connector.ModelBusRevision;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.ui.history.data.ModelBusLocalFileRevision;

/**
 * Provides info about history view modes
 * 
 * @author Alexander Gurov
 */
public interface IModelBusHistoryViewInfo {
	public static final int	MODE_BOTH	= 0x20;
	public static final int	MODE_LOCAL	= 0x40;
	public static final int	MODE_REMOTE	= 0x80;

	public static final int	MODE_MASK	= IModelBusHistoryViewInfo.MODE_BOTH | IModelBusHistoryViewInfo.MODE_REMOTE
												| IModelBusHistoryViewInfo.MODE_LOCAL;

	public IResource getResource();

	public IRepositoryResource getRepositoryResource();

	public ModelBusRevision getCurrentRevision();

	public boolean isPending();

	public boolean isRelatedPathsOnly();

	public boolean isGrouped();

	public int getMode();

	public ModelBusLocalFileRevision[] getLocalHistory();

	public ModelBusLogEntry[] getRemoteHistory();
}
