/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.history;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.team.ui.history.IHistoryPageSource;
import org.modelbus.team.eclipse.core.connector.ModelBusLogEntry;
import org.modelbus.team.eclipse.ui.history.model.ILogNode;

/**
 * ModelBus HistoryPage adapter factory
 * 
 * @author Alexander Gurov
 */
public class ModelBusHistoryAdapterFactory implements IAdapterFactory {
	private static final Class[]		ADAPTED_TYPES	= new Class[] { IHistoryPageSource.class, ModelBusLogEntry.class };

	private ModelBusHistoryPageSource	pageSource		= new ModelBusHistoryPageSource();

	public Class[] getAdapterList() {
		return ModelBusHistoryAdapterFactory.ADAPTED_TYPES;
	}

	public Object getAdapter(Object adaptableObject, Class adapterType) {
		if (IHistoryPageSource.class.equals(adapterType)) {
			return this.pageSource;
		}
		if (adaptableObject instanceof ILogNode) {
			return ((ILogNode) adaptableObject).getAdapter(adapterType);
		}
		return null;
	}

}
