/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.operation;

import org.eclipse.core.runtime.IProgressMonitor;
import org.modelbus.team.eclipse.core.connector.ModelBusRevision;
import org.modelbus.team.eclipse.core.operation.AbstractActionOperation;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;

/**
 * Allows us to get revision in the separate thread
 * 
 * @author Alexander Gurov
 */
public class GetRemoteResourceRevisionOperation extends AbstractActionOperation {
	protected IRepositoryResource	resource;
	protected String					revision;

	public GetRemoteResourceRevisionOperation(IRepositoryResource resource) {
		super("Operation.GetRemoteRevision");
		this.resource = resource;
		this.revision = ModelBusRevision.INVALID_REVISION_STRING;
	}

	public String getRevision() {
		return this.revision;
	}

	protected void runImpl(IProgressMonitor monitor) throws Exception {
		this.revision = this.resource.getRevision().getRevision();
	}

}
