/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexei Goncharov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.operation;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.modelbus.team.eclipse.core.connector.ModelBusRevision;
import org.modelbus.team.eclipse.core.operation.AbstractActionOperation;
import org.modelbus.team.eclipse.core.operation.IUnprotectedOperation;
import org.modelbus.team.eclipse.ui.properties.RevPropertiesView;
import org.modelbus.team.eclipse.ui.utility.UIMonitorUtility;

/**
 * Show revision properties operation
 * 
 * @author Alexei Goncharov
 */
public class ShowRevisionPropertiesOperation extends AbstractActionOperation {

	protected ModelBusRevision	revision;
	protected IWorkbenchPage	page;

	public ShowRevisionPropertiesOperation(IWorkbenchPage page, ModelBusRevision revision) {
		super("Operation.ShowRevProperties");
		this.page = page;
		this.revision = revision;
	}

	protected void runImpl(final IProgressMonitor monitor) throws Exception {
		UIMonitorUtility.getDisplay().syncExec(new Runnable() {
			public void run() {
				ShowRevisionPropertiesOperation.this.protectStep(new IUnprotectedOperation() {
					public void run(IProgressMonitor monitor) throws PartInitException {
						RevPropertiesView view = (RevPropertiesView) ShowRevisionPropertiesOperation.this.page.showView(RevPropertiesView.VIEW_ID);
						view.setLocationAndRevision(ShowRevisionPropertiesOperation.this.revision);
					}
				}, monitor, 1);

			}
		});
	}

}
