/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.panel.common;

import java.util.Set;

import org.eclipse.core.resources.IResource;
import org.eclipse.swt.widgets.Composite;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.core.resource.IRepositoryRoot;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;
import org.modelbus.team.eclipse.ui.preferences.ModelBusTeamPreferences;

/**
 * Select tag folder panel
 * 
 * @author Alexander Gurov
 */
public class TagPanel extends AbstractBranchTagPanel {

	// public TagPanel(IRepositoryRoot tagTo, boolean showStartsWith, Set existingNames) {
	// this(tagTo, showStartsWith, existingNames, new IResource[0]);
	// }
	//
	// public TagPanel(IRepositoryRoot tagTo, boolean showStartsWith, Set existingNames, IResource[] resources) {
	// super(tagTo, showStartsWith, existingNames, "TagPanel", "tag", resources);
	// }

	public TagPanel(IRepositoryRoot tagTo, boolean showStartsWith, Set existingNames, IRepositoryResource[] selectedRemoteResources) {
		this(tagTo, showStartsWith, existingNames, new IResource[0], selectedRemoteResources);
	}

	public TagPanel(IRepositoryRoot tagTo, boolean showStartsWith, Set existingNames, IResource[] resources,
			IRepositoryResource[] selectedRemoteResources) {
		super(tagTo, showStartsWith, existingNames, "TagPanel", "tag", resources, selectedRemoteResources);
	}

	public void createControlsImpl(Composite parent) {
		super.createControlsImpl(parent);
		if (this.startsWith
				&& ModelBusTeamPreferences.getRepositoryBoolean(ModelBusTeamUIPlugin.instance().getPreferenceStore(),
						ModelBusTeamPreferences.REPOSITORY_FORCE_EXTERNALS_FREEZE_NAME)) {
			this.freezeExternalsCheck.setSelection(true);
			this.freezeExternalsCheck.setEnabled(false);
		}
	}

	public String getHelpId() {
		return "org.modelbus.team.eclipse.help.tagDialogContext";
	}

}
