/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.properties;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;

/**
 * Remove property dialog
 * 
 * @author Alexander Gurov
 */
public class RemovePropertyDialog extends MessageDialog {

	protected boolean	recursive;
	protected boolean	isFile;

	public RemovePropertyDialog(Shell parentShell, boolean oneProperty, boolean isFile) {
		super(parentShell, ModelBusTeamUIPlugin.instance().getResource(oneProperty ? "RemoveProperty.Title.Single" : "RemoveProperty.Title.Multi"),
				null, ModelBusTeamUIPlugin.instance().getResource(oneProperty ? "RemoveProperty.Message.Single" : "RemoveProperty.Message.Multi"),
				MessageDialog.QUESTION, new String[] { IDialogConstants.YES_LABEL, IDialogConstants.NO_LABEL }, 0);

		this.recursive = false;
		this.isFile = isFile;
	}

	public boolean isRecursive() {
		return this.recursive;
	}

	protected Control createCustomArea(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH));

		if (!this.isFile) {
			Button recursive = new Button(composite, SWT.CHECK);
			recursive.setLayoutData(new GridData());
			recursive.setSelection(false);
			recursive.setText(ModelBusTeamUIPlugin.instance().getResource("RemoveProperty.Recursively"));
			recursive.addListener(SWT.Selection, new Listener() {
				public void handleEvent(Event event) {
					Button button = (Button) event.widget;
					RemovePropertyDialog.this.recursive = button.getSelection();
				}
			});
		}

		return composite;
	}

}
