package org.modelbus.team.eclipse.ui.repository.preferences;

import java.util.StringTokenizer;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	private static final String	PREFERENCE_DELIMITER	= ";";

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = ModelBusTeamUIPlugin.instance().getPreferenceStore();
		store.setDefault(PreferenceConstants.EXTENSIONS_PREFERENCE, PreferenceConstants.EXTENSIONS_DEFAULT);
	}

	public static String[] getExtensionPreference() {
		// TODO Auto-generated method stub
		return convert(ModelBusTeamUIPlugin.instance().getPreferenceStore().getString(PreferenceConstants.EXTENSIONS_PREFERENCE));
	}

	public static String[] getDefaultExtensionPreference() {
		// TODO Auto-generated method stub
		return convert(ModelBusTeamUIPlugin.instance().getPreferenceStore().getDefaultString(PreferenceConstants.EXTENSIONS_PREFERENCE));
	}

	public static void setExtensionPreference(String[] items) {
		// TODO Auto-generated method stub
		StringBuffer buffer = new StringBuffer();
		for (int i = 0; i < items.length; i++) {
			buffer.append(items[i]);
			buffer.append(PREFERENCE_DELIMITER);
		}
		ModelBusTeamUIPlugin.instance().getPreferenceStore().setValue(PreferenceConstants.EXTENSIONS_PREFERENCE, buffer.toString());

	}

	private static String[] convert(String preferenceValue) {
		StringTokenizer tokenizer = new StringTokenizer(preferenceValue, PREFERENCE_DELIMITER);
		int tokenCount = tokenizer.countTokens();
		String[] elements = new String[tokenCount];

		for (int i = 0; i < tokenCount; i++) {
			elements[i] = tokenizer.nextToken();
		}

		return elements;
	}

}
