/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.wizard;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;
import org.modelbus.team.eclipse.ui.wizard.checkoutas.SelectCheckoutResourcePage;

/**
 * Implements "Import from ModelBus" functionality
 * 
 * @author Alexander Gurov
 */
public class ImportFromModelBusWizard extends AbstractModelBusWizard implements INewWizard {
	protected SelectCheckoutResourcePage	selectResource;

	public ImportFromModelBusWizard() {
		super();
		this.setWindowTitle(ModelBusTeamUIPlugin.instance().getResource("ImportFromModelBusWizard.Title"));
	}

	public void addPages() {
		this.addPage(this.selectResource = new SelectCheckoutResourcePage());
	}

	public IWizardPage getNextPage(IWizardPage page) {
		IWizardPage retVal = null;
		retVal = super.getNextPage(page);

		if (retVal instanceof SelectCheckoutResourcePage) {
			// this.selectResource.setRepositoryLocation(this.selectLocation != null && this.selectLocation.useExistingLocation() ?
			// this.selectLocation.getRepositoryLocation() : this.addLocation.getRepositoryLocation());
		}

		return retVal;
	}

	public IWizardPage getPreviousPage(IWizardPage page) {
		if (page instanceof SelectCheckoutResourcePage
		// &&
		// this.selectLocation != null &&
		// this.selectLocation.useExistingLocation()
		) {
			return super.getPreviousPage(super.getPreviousPage(page));
		}
		return super.getPreviousPage(page);
	}

	public boolean canFinish() {
		IWizardPage currentPage = this.getContainer().getCurrentPage();
		return currentPage instanceof SelectCheckoutResourcePage && this.selectResource.isPageComplete();
	}

	public boolean performFinish() {
		IRepositoryResource[] resources = this.selectResource.getSelectedResources();
		// MES
		// CheckoutAsWizard checkoutWizard = new CheckoutAsWizard(resources, this.addLocation.getOperationToPeform());
		CheckoutAsWizard checkoutWizard = new CheckoutAsWizard(resources);

		WizardDialog dialog = new WizardDialog(this.getShell(), checkoutWizard);
		dialog.create();
		dialog.getShell().setSize(Math.max(CheckoutAsWizard.SIZING_WIZARD_WIDTH, dialog.getShell().getSize().x),
				CheckoutAsWizard.SIZING_WIZARD_HEIGHT);
		return dialog.open() == 0 ? true : false;
		// return true;
		// throw new RuntimeException("TODOMWA30");
	}

	public void init(IWorkbench workbench, IStructuredSelection selection) {

	}

}
