/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexei Goncharov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.modelbusstorage.events;

import org.modelbus.team.eclipse.core.connector.ModelBusProperty;
import org.modelbus.team.eclipse.core.connector.ModelBusRevision;

/**
 * This event is sent when the revision property is changed.
 * 
 * @author Alexei Goncharov
 */
public class RevisonPropertyChangeEvent {

	public static final int		SET		= 0;
	public static final int		REMOVED	= 1;

	protected int				action;
	protected ModelBusRevision	revision;
	protected ModelBusProperty	property;

	public RevisonPropertyChangeEvent(int action, ModelBusRevision revision, ModelBusProperty property) {
		this.revision = revision;
		this.property = property;
		this.action = action;
	}

	public int getAction() {
		return this.action;
	}

	public ModelBusRevision getRevision() {
		return this.revision;
	}

	public ModelBusProperty getProperty() {
		return this.property;
	}
}
