/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.operation;

import org.modelbus.team.eclipse.core.connector.ModelBusRevision;

/**
 * Interface which will allow to return produced revision number for the operations which modify repository
 * 
 * @author Alexander Gurov
 */
public interface IRevisionProvider {
	public static class RevisionPair {
		public final ModelBusRevision		revision;
		public final String[]	paths;

		public RevisionPair(ModelBusRevision revision, String[] paths) {
			this.revision = revision;
			this.paths = paths;
		}
	}

	public RevisionPair[] getRevisions();

}
