/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.operation.local;

import java.util.ArrayList;
import java.util.Arrays;

import org.eclipse.core.resources.IResource;
import org.modelbus.team.eclipse.core.connector.ModelBusMergeStatus;

/**
 * Merge scope info: merge to, merge from resources and merge start revision
 * 
 * @author Alexander Gurov
 */
public abstract class AbstractMergeSet {
	public final IResource[]					to;

	protected ArrayList<ModelBusMergeStatus>	statuses;

	public AbstractMergeSet(IResource[] to) {
		this.to = to;
		this.statuses = new ArrayList<ModelBusMergeStatus>();
	}

	public ModelBusMergeStatus[] getStatuses() {
		return this.statuses.toArray(new ModelBusMergeStatus[this.statuses.size()]);
	}

	public void setStatuses(ModelBusMergeStatus[] statuses) {
		this.statuses.clear();
		this.addStatuses(statuses);
	}

	public void addStatuses(ModelBusMergeStatus[] statuses) {
		if (statuses != null) {
			this.statuses.addAll(Arrays.asList(statuses));
		}
	}

}
