package org.modelbus.team.eclipse.core.operation.remote;

import org.eclipse.core.runtime.IProgressMonitor;
import org.modelbus.team.eclipse.core.connector.IModelBusConnector;
import org.modelbus.team.eclipse.core.connector.ModelBusConnector;
import org.modelbus.team.eclipse.core.operation.IUnprotectedOperation;
import org.modelbus.team.eclipse.core.operation.ModelBusProgressMonitor;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;

public class ControlOperation extends AbstractRepositoryOperation {

	private String	fragmentURI;
	private String	fragmentFileLocation;
	private String	message;

	public ControlOperation(String fragmentURI, String fragmentFileLocation, String message, IRepositoryResource[] resources) {
		super("Operation.Control", resources);
		// TODO Auto-generated constructor stub
		this.fragmentURI = fragmentURI;
		this.fragmentFileLocation = fragmentFileLocation;
		this.message = message;
	}

	@Override
	protected void runImpl(final IProgressMonitor monitor) throws Exception {
		// TODO Auto-generated method stub
		final IModelBusConnector proxy = ModelBusConnector.getModelBusConnector();
		this.protectStep(new IUnprotectedOperation() {
			public void run(IProgressMonitor monitor) throws Exception {
				if (!monitor.isCanceled()) {
					// ProgressMonitorUtility.doTask(ControlOperation.this, monitor, DEFAULT_WEIGHT, DEFAULT_WEIGHT);
					proxy.control(fragmentURI, fragmentFileLocation, ControlOperation.this.message, new ModelBusProgressMonitor(
							ControlOperation.this, monitor, null));

				}

			}
		}, monitor, 1);

	}

}
