/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.core.utility;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import org.modelbus.team.eclipse.core.ModelBusTeamPlugin;

/**
 * ModelBus-specific URL stream handler
 * 
 * @author Alexander Gurov
 */
public class ModelBusURLStreamHandler extends URLStreamHandler {
	protected URL	url;

	public ModelBusURLStreamHandler() {
	}

	public URL getURL() {
		return this.url;
	}

	protected URLConnection openConnection(URL u) throws IOException {
		return null;
	}

	public void setHost(String host) {
		this.setURL(this.url, this.url.getProtocol(), host, this.url.getPort(), this.url.getAuthority(), this.url.getUserInfo(), this.url.getPath(),
				this.url.getQuery(), this.url.getRef());
	}

	protected void parseURL(URL u, String spec, int start, int limit) {
		String protocol = u.getProtocol();
		if (!protocol.equals("file") && !protocol.equals("modelbus") && !protocol.equals("http") && !protocol.equals("https")
				&& !protocol.equals("modelbus+ssh")) {
			String errMessage = ModelBusTeamPlugin.instance().getResource("Error.UnknownProtocol", new String[] { protocol });
			throw new RuntimeException(errMessage);
		}
		this.url = u;
		super.parseURL(u, spec, start, limit);
	}

}
