/**
 *  ModelBus is the means to interact with models in a distributed
 * consistent way.
 * 
 *  Copyright (C) 2008  Tom Ritter, Christian Hein, Michael Wagner
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.modelbus.team.eclipse.model;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;

/**
 * TODO comment
 * 
 * @author Michael Wagner
 * 
 */

public class ModelObjectElementFile extends ModelFile {

	public static final String				MODEL_OBJECT_ELEMENTFILE_EXTENSION	= "moe";

	private final ModelObjectDefinitionFile	parent;

	public static boolean isMoeFile(IResource resource) {
		return resource instanceof IFile && resource.getFileExtension().equals(MODEL_OBJECT_ELEMENTFILE_EXTENSION);
	}

	public ModelObjectElementFile(ModelObjectDefinitionFile parent, IFile file) {
		super(file);
		this.parent = parent;
	}

	public ModelObject[] getChildren() {
		return new ModelObject[0];
	}

	public ModelObject getParent() {
		return parent;
	}

	public void delete() throws CoreException {
		parent.remove(this);
		super.delete();
	}

}
