package org.modelbus.team.eclipse.repository;

import org.eclipse.jface.preference.IPreferenceStore;
import org.modelbus.core.lib.util.LocationsUtilFactory;

public class RepositoryLocationHelper {
	private RepositoryLocationHelper() {
	}

	public static String getPropertyRepositoryLocation() {
		// TODO: men use this to configure the team provider using the preferences pages
		/*
		 * final String repoLocation = org.modelbus.preferences.user.Activator.getDefault().getPreferenceStore().getString(
		 * org.modelbus.preferences.user.preferences.PreferenceConstants.REPOSITORY_LOCATION_STRING);
		 * 
		 * if(repoLocation == null || "".equals(repoLocation)){
		 * System.out.println("WARNING: ModelBus repository location must be set on ModelBus preferences page."); }
		 */

		String repoLocation;

		try {
			repoLocation = LocationsUtilFactory.getInstance().getLocationsUtil().getRepositoryLocation();
		} catch (Exception exc) {
			exc.printStackTrace();
			return null;
		}

		return repoLocation;
	}

	public static String getPropertyConfigurationModelPath() {
		final IPreferenceStore store = getPreferencesStore();
		
		if(store == null){
			return null;
		}
		
		return store.getString(org.modelbus.preferences.user.preferences.PreferenceConstants.CONFIG_MODEL_PATH_STRING);
	}

	public static Boolean getPropertyUseSSL() {
		final IPreferenceStore store = getPreferencesStore();
		
		if(store == null){
			return null;
		}
		
		return store.getBoolean(org.modelbus.preferences.user.preferences.PreferenceConstants.USE_SSL_BOOLEAN);
	}
	
	private static IPreferenceStore getPreferencesStore(){
		return org.modelbus.preferences.user.Activator.getDefault().getPreferenceStore();
	}
}
