package org.modelbus.team.eclipse.repository.history;

import java.io.IOException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFileState;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.team.core.TeamException;
import org.eclipse.team.core.history.IFileRevision;
import org.eclipse.team.core.history.provider.FileHistory;
import org.eclipse.team.core.variants.IResourceVariant;
import org.eclipse.team.internal.core.history.LocalFileRevision;
import org.modelbus.dosgi.repository.descriptor.InvalidRevisionException;
import org.modelbus.dosgi.repository.descriptor.NonExistingResourceException;
import org.modelbus.dosgi.repository.descriptor.RepositoryAuthentificationException;
import org.modelbus.dosgi.repository.descriptor.RepositoryDirEntry;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusRepositoryResourceVariant;

public class ModelBusRepositoryHistory extends FileHistory {

	private IFile				file;
	protected IFileRevision[]	revisions;

	public ModelBusRepositoryHistory(IFile file) {
		this.file = file;
	}

	public IFileRevision[] getContributors(IFileRevision revision) {
		return null;
	}

	public IFileRevision getFileRevision(String id) {
		return null;
	}

	public IFileRevision[] getFileRevisions() {
		return revisions;
	}

	public IFileRevision[] getTargets(IFileRevision revision) {
		return null;
	}

	public void refresh(IProgressMonitor monitor) {
		try {
			RepositoryProvider provider = RepositoryProvider.getProvider(file.getProject());
			if (provider != null && provider instanceof ModelBusRepositoryProvider) {
				ModelBusRepositoryProvider fileProvider = (ModelBusRepositoryProvider) provider;
				IResourceVariant resVar = null;

				try {
					resVar = fileProvider.getResourceVariant(file);
				} catch (RepositoryAuthentificationException e) {
					// TODO Auto-generated catch block
					throw new RuntimeException(e);
				} catch (NonExistingResourceException e) {
					// TODO Auto-generated catch block
					throw new RuntimeException(e);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					throw new RuntimeException(e);
				} catch (InvalidRevisionException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					throw new RuntimeException(e);
				}
				if (resVar instanceof ModelBusRepositoryResourceVariant) {
					ModelBusRepositoryResourceVariant resVarF = (ModelBusRepositoryResourceVariant) resVar;
					RepositoryDirEntry javaFile = resVarF.getFile();
					// Get local history items
					IFileState[] states = file.getHistory(monitor);
					revisions = new IFileRevision[states.length + 1];
					int i = 0;
					for (; i < states.length; i++) {
						revisions[i] = new LocalFileRevision(states[i]);
					}
					revisions[i] = new ModelBusRepositoryFileRevision(javaFile);
				}
			}
		} catch (TeamException e) {
		} catch (CoreException e) {
		}
	}

}
