package org.modelbus.team.eclipse.repository.ui;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.modelbus.team.eclipse.repository.Policy;

public class LockAction extends ModelBusRepositoryAction {

	@Override
	protected void execute(IAction arg0) throws InvocationTargetException, InterruptedException {
		try {
			LockOperation operation = new LockOperation(getTargetPart(), ModelBusRepositoryOperation.createScopeManager(
					Policy.bind("LockAction.working"), getSelectedMappings())); //$NON-NLS-1$
			// operation.setOverwriteIncoming(isOverrideIncoming());
			operation.run();
		} catch (InvocationTargetException e) {
			handle(e, null, Policy.bind("LockAction.problemMessage")); //$NON-NLS-1$
		} catch (InterruptedException e) {
			// Ignore
		}

	}

	@Override
	public boolean isEnabled() {
		IResource[] resources = getSelectedResources();
		if (resources == null) {
			return false;
		}
		if (resources.length != 1) {
			return false;
		}
		if (resources[0] == null) {
			return false;
		}
		IResource resource = resources[0];
		// String remoteFileLocation = LockHelper.getLockHelper().getObjectLocation(URI.createURI(resource.getLocationURI().toString()),
		// null);//modelBusRepositoryProvider.getRepositoryPath(resource);
		try {
			String user = LockHelper.getLockHelper().objectLockedBy(resource);
			if (user != null) {
				return false;
			}
		} catch (Exception e) {
			return false;
		}
		return true;
	}

}
