package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.team.core.TeamException;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusRepositorySubscriber;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusThreeWaySynchronizer;

public class ModelBusProjectDecorator extends LabelProvider implements ILightweightLabelDecorator {

	public void decorate(Object element, IDecoration decoration) {
		// TODO Auto-generated method stub
		ModelBusRepositoryProvider provider;
		if (element instanceof IProject
				&& (provider = (ModelBusRepositoryProvider) RepositoryProvider.getProvider((IProject) element, ModelBusRepositoryPlugin.PROVIDER_ID)) != null) {
			try {
				String revision = ((ModelBusThreeWaySynchronizer) ModelBusRepositorySubscriber.getInstance().getSynchronizer())
						.getWorkingCopyRevision((IProject) element);
				String path = provider.getRepositoryPath((IProject) element);

				decoration.addSuffix(" " + revision + " [" + path + "]");

			} catch (TeamException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}

	}
}
