package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.viewers.IDecoration;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusRepositorySubscriber;

public class ModelBusProjectDecoratorWrapper extends AbstractModelBusDecoratorWrapper {

	private ModelBusProjectDecorator	modelBusProjectDecorator;

	public ModelBusProjectDecoratorWrapper() {
		super();
		ModelBusRepositorySubscriber.getInstance().getSynchronizer().addListener(this);
	}

	@Override
	public void decorate(Object element, IDecoration decoration) {
		// TODO Auto-generated method stub
		if (element instanceof IProject && isModelBusShared((IResource) element)) {
			this.getModelBusProjectDecorator().decorate(element, decoration);
		}

	}

	private synchronized ModelBusProjectDecorator getModelBusProjectDecorator() {

		if (this.modelBusProjectDecorator == null) {
			this.modelBusProjectDecorator = new ModelBusProjectDecorator();
		}
		return this.modelBusProjectDecorator;
	}

}
