package org.modelbus.team.eclipse.repository.ui;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.team.core.TeamException;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryPlugin;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusRepositorySubscriber;
import org.modelbus.team.eclipse.repository.subscriber.ModelBusThreeWaySynchronizer;

public class ModelBusResourceDecorator extends LabelProvider implements ILightweightLabelDecorator {

	public void decorate(Object element, IDecoration decoration) {
		// TODO Auto-generated method stub
		if ((element instanceof IFolder || element instanceof IFile)
				&& (RepositoryProvider.getProvider(((IResource) element).getProject(), ModelBusRepositoryPlugin.PROVIDER_ID)) != null) {
			try {
				String revision = ((ModelBusThreeWaySynchronizer) ModelBusRepositorySubscriber.getInstance().getSynchronizer())
						.getWorkingCopyRevision((IResource) element);
				//TODO replace by constant
				if (!"-2".equals(revision)) {
					decoration.addSuffix(" " + revision);

				}
			} catch (TeamException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}

	}

}
