package org.modelbus.team.eclipse.repository.ui;

import org.modelbus.core.lib.IRepositoryHelper;
import org.modelbus.dosgi.repository.descriptor.LockInfo;
import org.modelbus.dosgi.repository.descriptor.LockedException;
import org.modelbus.dosgi.repository.descriptor.NonExistingResourceException;
import org.modelbus.dosgi.repository.descriptor.RepositoryAuthentificationException;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryHelper;
import org.modelbus.team.eclipse.repository.ModelBusRepositoryProvider;
import org.modelbus.team.eclipse.repository.UserSessionHelper;

public class UiHelper {

	// TODOMWA

	public static boolean isUnlockable(ModelBusRepositoryProvider modelBusRepositoryProvider, String url) throws LockedException,
			NonExistingResourceException {

		// String repLocation = org.modelbus.preferences.ModelBusPreferencePlugin
		// .getDefault()
		// .getPreferenceStore()
		// .getString(
		// org.modelbus.preferences.PreferenceConstants.REPOSITORY_LOCATION_STRING);
		// boolean checkDependencies = org.modelbus.preferences.dependencies.DependenciesPreferencePlugin
		// .getDefault()
		// .getPreferenceStore()
		// .getBoolean(org.modelbus.preferences.dependencies.preferences.PreferenceConstants.CHECK_DEPENDENCIES);
		// String[] modelExtensions = org.modelbus.preferences.dependencies.DependenciesPreferencePlugin
		// .getDefault().getExtensionPreference();
		// RepositoryHelper repositoryHelper = new RepositoryHelper(repLocation,checkDependencies,modelExtensions);
		IRepositoryHelper repositoryHelper = ModelBusRepositoryHelper.getRepositoryHelper();
		LockInfo[] lockInfos;
		try {
			lockInfos = repositoryHelper.getLocks(UserSessionHelper.getSession(), "");
		} catch (RepositoryAuthentificationException e) {
			// TODO Auto-generated catch block
			throw new RuntimeException(e);
		}
		for (int i = 0; i < lockInfos.length; i++) {
			LockInfo lockInfo = lockInfos[i];
			if (url.equals(lockInfo.getUrl()) && lockInfo.getUserName().equals(UserSessionHelper.getPropertyUserName())) {
				return true;
			}
		}
		return false;
	}
}
