package org.modelbus.team.eclipse.ui.action.remote;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.edit.provider.DelegatingWrapperItemProvider;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.modelbus.team.eclipse.core.operation.AbstractActionOperation;
import org.modelbus.team.eclipse.core.operation.IActionOperation;
import org.modelbus.team.eclipse.ui.action.AbstractRepositoryTeamAction;

public class CopyURIAction extends AbstractRepositoryTeamAction {

	protected String	uri;

	public CopyURIAction() {
		super();
	}

	@Override
	public boolean isEnabled() {
		// TODO Auto-generated method stub
		IStructuredSelection selection = this.getSelection();
		Object firstElement = selection.getFirstElement();
		if (firstElement instanceof EObject) {
			this.uri = EcoreUtil.getURI((EObject) firstElement).toString();
			return true;
		} else if (firstElement instanceof DelegatingWrapperItemProvider) {
			Object value = ((DelegatingWrapperItemProvider) firstElement).getValue();
			if (value instanceof FeatureMap.Entry) {
				Object object = ((FeatureMap.Entry) value).getValue();
				if (object instanceof EObject) {
					this.uri = EcoreUtil.getURI((EObject) object).toString();
					return true;
				}
			}
		}
		return false;
	}

	@Override
	public void runImpl(IAction action) {
		// TODO Auto-generated method stub
		IActionOperation op = new AbstractActionOperation("Operation.CopyURI") {
			protected void runImpl(IProgressMonitor monitor) throws Exception {
				Clipboard clipboard = new Clipboard(CopyURIAction.this.getShell().getDisplay());
				try {
					clipboard.setContents(new Object[] { CopyURIAction.this.uri }, new Transfer[] { TextTransfer.getInstance() });
				} finally {
					clipboard.dispose();
				}
			}
		};
		this.runBusy(op);

	}

}
