/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.crashrecovery.invalidmeta;

import java.util.List;

import org.eclipse.core.resources.IProject;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;
import org.modelbus.team.eclipse.ui.panel.AbstractDialogPanel;

/**
 * The panel allows us to acquire user solution about which valid connector we should use in order to access the project.
 * 
 * @author Alexander Gurov
 */
public class ValidConnectorsSelectionPanel extends AbstractDialogPanel {
	protected Combo	modelbusConnectorField;

	// protected IModelBusConnectorFactory []factories;
	// protected String modelbusConnector; CHECKMWA

	public ValidConnectorsSelectionPanel(IProject project, List validClients) {
		super();
		this.dialogTitle = ModelBusTeamUIPlugin.instance().getResource("ValidConnectorsSelectionPanel.Title", new String[] { project.getName() });
		this.dialogDescription = ModelBusTeamUIPlugin.instance().getResource("ValidConnectorsSelectionPanel.Description");
		this.defaultMessage = ModelBusTeamUIPlugin.instance().getResource("ValidConnectorsSelectionPanel.Message");

		// this.factories = (IModelBusConnectorFactory [])validClients.toArray(new IModelBusConnectorFactory[validClients.size()]);
	}

	public Point getPrefferedSizeImpl() {
		return new Point(500, 60);
	}

	public void postInit() {
		super.postInit();
		// this.modelbusConnector = this.factories[this.modelbusConnectorField.getSelectionIndex()].getId();
	}

	protected void createControlsImpl(Composite parent) {
		GridLayout layout = null;
		GridData data = null;

		Composite composite = new Composite(parent, SWT.NONE);
		layout = new GridLayout();
		layout.numColumns = 2;
		layout.marginHeight = layout.marginWidth = 0;
		composite.setLayout(layout);
		data = new GridData(GridData.FILL_BOTH);
		composite.setLayoutData(data);

		Label label = new Label(composite, SWT.NULL);
		data = new GridData();
		label.setLayoutData(data);
		label.setText(ModelBusTeamUIPlugin.instance().getResource("ValidConnectorsSelectionPanel.Clients"));

		this.modelbusConnectorField = new Combo(composite, SWT.READ_ONLY);
		data = new GridData(GridData.FILL_HORIZONTAL);
		this.modelbusConnectorField.setLayoutData(data);
		// Arrays.sort(this.factories, new Comparator() {
		// public int compare(Object o1, Object o2) {
		// return ((IModelBusConnectorFactory)o1).getName().compareTo(((IModelBusConnectorFactory)o2).getName());
		// }
		// });
		// String []items = new String[this.factories.length];
		// for (int i = 0; i < items.length; i++) {
		// items[i] = this.factories[i].getName() + " (" + this.factories[i].getClientVersion().replace('\n', ' ') + ")";
		// }
		// this.modelbusConnectorField.setItems(items);
		this.modelbusConnectorField.select(0);
		// this.modelbusConnectorField.addSelectionListener(new SelectionAdapter() {
		// public void widgetSelected(SelectionEvent e) {
		// ValidConnectorsSelectionPanel.this.modelbusConnector =
		// ValidConnectorsSelectionPanel.this.factories[ValidConnectorsSelectionPanel.this.modelbusConnectorField.getSelectionIndex()].getId();
		// }
		// });
	}

	protected void cancelChangesImpl() {
	}

	protected void saveChangesImpl() {
		// String oldId = CoreExtensionsManager.instance().getModelBusConnectorFactory().getId();
		// if (!oldId.equals(this.modelbusConnector)) {
		// ModelBusTeamPreferences.setCoreString(ModelBusTeamUIPlugin.instance().getPreferenceStore(),
		// ModelBusTeamPreferences.CORE_ModelBusCONNECTOR_NAME, this.modelbusConnector);
		// ModelBusTeamUIPlugin.instance().savePluginPreferences();
		// // destroy all cached proxies
		// ModelBusRemoteStorage.instance().dispose();
		// }
	}

}
