/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.dialog;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.modelbus.team.eclipse.core.utility.FileUtility;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;

/**
 * Disconnect from repository confirmation dialog
 * 
 * @author Alexander Gurov
 */
public class DisconnectDialog extends MessageDialog {

	protected boolean	dropModelBusFolders;

	public DisconnectDialog(Shell parentShell, IProject[] projects) {
		super(parentShell, ModelBusTeamUIPlugin.instance().getResource("DisconnectDialog.Title"), null, ModelBusTeamUIPlugin.instance().getResource(
				"DisconnectDialog.Message", new String[] { FileUtility.getNamesListAsString(projects) }), MessageDialog.QUESTION, new String[] {
				IDialogConstants.YES_LABEL, IDialogConstants.NO_LABEL }, 0);

		this.dropModelBusFolders = false;
	}

	protected Control createCustomArea(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout());

		Button dropModelBusFoldersButton = new Button(composite, SWT.RADIO);
		dropModelBusFoldersButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Button button = (Button) e.widget;
				DisconnectDialog.this.dropModelBusFolders = button.getSelection();
			}
		});

		dropModelBusFoldersButton.setText(ModelBusTeamUIPlugin.instance().getResource("DisconnectDialog.Option.dropModelBusMeta"));

		Button leaveModelBusFoldersButton = new Button(composite, SWT.RADIO);

		leaveModelBusFoldersButton.setText(ModelBusTeamUIPlugin.instance().getResource("DisconnectDialog.Option.leaveModelBusMeta"));

		// set initial state
		dropModelBusFoldersButton.setSelection(false);
		leaveModelBusFoldersButton.setSelection(true);

		// WorkbenchHelp.setHelp(composite, IHelpContextIds.DISCONNECT_ACTION);

		return composite;
	}

	public boolean dropModelBusFolders() {
		return this.dropModelBusFolders;
	}

}
