/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.panel.remote;

import org.modelbus.team.eclipse.core.connector.ModelBusRevision;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;
import org.modelbus.team.eclipse.ui.composite.RepositoryResourceSelectionComposite;
import org.modelbus.team.eclipse.ui.panel.common.AbstractRepositoryResourceSelectionPanel;

/**
 * Compare operation repository resource selection panel
 * 
 * @author Alexander Gurov
 */
public class ComparePanel extends AbstractRepositoryResourceSelectionPanel {
	public ComparePanel(IRepositoryResource baseResource) {
		super(baseResource, ModelBusRevision.INVALID_REVISION_DESCRIPTOR, ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Title"),
				ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Description"), "compareUrl", ModelBusTeamUIPlugin.instance().getResource(
						"ComparePanel.Selection.Title"), ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Selection.Description"),
				RepositoryResourceSelectionComposite.TEXT_BASE);
		this.defaultMessage = ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Message");
	}

	public ComparePanel(IRepositoryResource baseResource, ModelBusRevision revision) {
		super(baseResource, revision, ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Title"), ModelBusTeamUIPlugin.instance().getResource(
				"ComparePanel.Description"), "compareUrl", ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Selection.Title"),
				ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Selection.Description"), RepositoryResourceSelectionComposite.TEXT_BASE);
		this.defaultMessage = ModelBusTeamUIPlugin.instance().getResource("ComparePanel.Message");
	}

	public String getHelpId() {
		return "org.modelbus.team.eclipse.help.remote_compareDialogContext";
	}

}
