/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexander Gurov - Initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.synchronize.variant;

import java.text.MessageFormat;

import org.modelbus.team.eclipse.core.IStateFilter;
import org.modelbus.team.eclipse.core.ModelBusTeamPlugin;
import org.modelbus.team.eclipse.core.resource.ILocalResource;

/**
 * Abstract remote resource variant
 * 
 * @author Alexander Gurov
 */
public abstract class RemoteResourceVariant extends ResourceVariant {
	protected static String	modelbusAuthor;

	public RemoteResourceVariant(ILocalResource local) {
		super(local);
		RemoteResourceVariant.modelbusAuthor = ModelBusTeamPlugin.instance().getResource("ModelBusInfo.Author");
	}

	protected String getCacheId() {
		return "Remote: " + super.getCacheId();
	}

	public String getContentIdentifier() {
		if (IStateFilter.SF_PREREPLACED.accept(this.local)) {
			return "";
		}
		String retVal = super.getContentIdentifier();
		if ((!this.isNotOnRepository() || this.local.isCopied()) && this.local.getAuthor() != null) {
			retVal += " " + MessageFormat.format(RemoteResourceVariant.modelbusAuthor, new Object[] { this.local.getAuthor() });
		}
		return retVal;
	}

}
