package org.modelbus.team.eclipse.ui.wizard;

import org.eclipse.emf.ecore.EObject;
import org.modelbus.team.eclipse.core.resource.IRepositoryResource;

public class FragmentLocationWizard extends AbstractModelBusWizard {

	protected SelectFragmentDestinationPage	destinationPage;

	protected IRepositoryResource			selectedResource;
	protected EObject						fragment;
	protected IRepositoryResource			destination;
	protected String						newName;

	public FragmentLocationWizard(IRepositoryResource selectedResource, EObject fragment) {
		super();
		this.selectedResource = selectedResource;
		this.fragment = fragment;
		this.setWindowTitle("Fragment Location Selection");
	}

	public void addPages() {
		this.addPage(this.destinationPage = new SelectFragmentDestinationPage(this.selectedResource, this.fragment));

	}

	public boolean canFinish() {
		// IWizardPage currentPage = this.getContainer().getCurrentPage();
		// if (currentPage instanceof SelectDestinationPage) {
		// return false;
		// }
		return super.canFinish();
	}

	public boolean performFinish() {
		this.destination = this.destinationPage.getDestination();
		this.newName = this.destinationPage.getNewResourceName();

		return true;
	}

	public String getNewName() {
		return this.newName;
	}

	public IRepositoryResource getDestination() {
		return this.destination;
	}
}
