/*******************************************************************************
 * Copyright (c) 2005-2008 Polarion Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Alexei Goncharov (Polarion Software) - initial API and implementation
 *******************************************************************************/

package org.modelbus.team.eclipse.ui.wizard.copymove;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.modelbus.team.eclipse.ui.ModelBusTeamUIPlugin;
import org.modelbus.team.eclipse.ui.composite.CommentComposite;
import org.modelbus.team.eclipse.ui.wizard.AbstractVerifiedWizardPage;

/**
 * Comment page for Copy To or Move To wizard.
 * 
 * @author Alexei Goncharov
 */
public class CommentWizardPage extends AbstractVerifiedWizardPage {
	protected CommentComposite	commentComposite;

	public CommentWizardPage(boolean isMove) {
		super(CommentWizardPage.class.getName(), isMove ? ModelBusTeamUIPlugin.instance().getResource("MoveToAction.Comment.Title")
				: ModelBusTeamUIPlugin.instance().getResource("CopyToAction.Comment.Title"), ModelBusTeamUIPlugin.instance().getImageDescriptor(
				"icons/wizards/newconnect.png"));
		this.setDescription(ModelBusTeamUIPlugin.instance().getResource("CopyMove.Comment.Message"));
	}

	protected Composite createControlImpl(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout(1, true);
		layout.marginWidth = 5;
		layout.marginHeight = 5;
		composite.setLayout(layout);
		GridData data = new GridData(GridData.FILL_BOTH);
		composite.setLayoutData(data);
		this.commentComposite = new CommentComposite(composite, this);
		this.commentComposite.setLayoutData(new GridData(GridData.FILL_BOTH));
		return composite;
	}

	public String getComment() {
		this.commentComposite.saveChanges();
		return this.commentComposite.getMessage();
	}

}
